#include <dirent.h>
#include <iostream>
#include <queue>
#include <cstdlib>
#include <windows.h>
#include <conio.h>
#include <cstdio>

//Definiciones de colores.
#define NEGRO 0
#define AZULOSCURO 1
#define VERDEOSCURO 2
#define PURPURA 5
#define BLANCOOSCURO 7
#define GRIS 8
#define AZUL 9
#define CYAN 11
#define ROJO 12
#define AMARILLO 14
#define BLANCO 15

//Definicin de tamao de pantalla.
#define ANCHOPANTALLA 100
#define ALTOPANTALLA 50
#define MAX_FILA 5
#define MAX_COL 88

//Definicin de teclas.
#define BORRAR 8
#define ENTER 13
#define ESC 27
#define F1 59
#define F2 60
#define ARRIBA 72
#define IZQUIERDA 75
#define DERECHA 77
#define ABAJO 80


#include <fstream>
#include <ctime>
#include <string>
#include <sstream>
using namespace std;

struct Pregunta {
	int idCategoria;    
	int idPregunta;
	int numeroGrupo;
	string pregunta;
	string opciones[4];
	int opcionCorrecta;    //Subndice de la opcin correcta.
}; 

void gotoxy(int x,int y);
void colores(int texto,int fondo);
int menu();
bool confirmarAccionSalir(string texto,int size);
int menu_categorias();
void cambiar_nombre(int opt);
void imprimirTitulo(string, int);
void imprimirDescripcion();
void centrarTexto(string linea,int y);
void mostrarPreguntas();
void cargaDePreguntas(Pregunta [MAX_FILA][MAX_COL]);
int armarListaDePreguntas(string[] , Pregunta [MAX_FILA][MAX_COL]);
//string to_string(int a);
void cambiarPregunta(int id, int cat, string listaDePreguntas[]);
string escribir (int x, int y);
int cargarLineas (string lineas[]);
void actualizar_tamanios();
void importarPreguntas();


//Variables globales.
int colorTexto,colorFondo;
string categorias[5];
Pregunta matrizPreguntas[MAX_FILA][MAX_COL];
int tamanoCategorias [5];


int main(){
	int opcion; bool deseaSalir = false; int opt2;
	system("mode con: cols=100 lines=50");
	const char * categor="categorias.txt";
	ifstream catego;
	catego.open(categor, ios::in);
	int i=0;
	while(!catego.eof()){
		getline(catego,categorias[i],' ');
		string temp; 
		getline(catego,temp,' ');
		tamanoCategorias[i] = atoi(temp.c_str());
		i++;
	}
	do{
		opcion = menu();
		switch(opcion){
			case 1:{ opt2 = menu_categorias();
				if(opt2!=6)
				cambiar_nombre(opt2);
				break;}
			case 2: mostrarPreguntas(); break;
			case 3: importarPreguntas(); break;
			case 4: deseaSalir = confirmarAccionSalir("Estas seguro que queres salir de la aplicacion",46); break;
		}
	} while(!deseaSalir);
	return 0;
}


int menu(){ 
	int opcion = 0;
	while (opcion < 1 || opcion > 4){
		colores(BLANCO,NEGRO);
		system("cls");
		SetConsoleTextAttribute(GetStdHandle (STD_OUTPUT_HANDLE), 7);
		for (int i=35; i<=75;i++) { //marco menu
			gotoxy(i,16); printf ("%c",205); //lineas horizontales
			gotoxy(i,28); printf ("%c",205); 
		}
		for (int i=17; i<28; i++) {
			gotoxy (34,i); printf ("%c",186); //lineas verticales 
			gotoxy (75,i);printf ("%c",186);
		}
		gotoxy (34,16); printf ("%c",201); //esquinas
		gotoxy (34,28); printf ("%c",200); 
		gotoxy (75,16); printf ("%c",187); 
		gotoxy (75,28); printf ("%c",188);
		gotoxy (36,17);cout<<"----------- MEN"<<(CHAR)233<<" PRINCIPAL -----------"; 
		gotoxy (36,19);cout<<"  1| Renombrar Categorias"; 
		gotoxy (36,20);cout<<"  2| Gestionar Preguntas";
		gotoxy (36,21);cout<<"  3| Importar Preguntas"; 
		gotoxy (36,23);cout<<"  4| Salir"; 
		gotoxy (36,27);cout<<"  Elija una opcion: "; 
		cin >> opcion;
	}
	return opcion;
}

bool confirmarAccionSalir(string texto,int size){
	system("cls");
	int colorTextoPrevio = colorTexto, colorFondoPrevio = colorFondo,tam = size+12,x = (ANCHOPANTALLA - tam)/2,y = (ALTOPANTALLA - 5) / 2 - 1;
	char rta;
	colores(ROJO,NEGRO);
	gotoxy(x-2,y-2); for(int i=0;i<tam+4;i++) printf("%c",175);
	colores(NEGRO,AMARILLO);
	gotoxy(x,y++); for(int i=0;i<tam;i++) printf(" ");
	gotoxy(x,y++); for(int i=0;i<tam;i++) printf(" ");
	gotoxy(x,y++); printf("\a\a\a  %c%s? (S/N)  ",168,texto.c_str());
	gotoxy(x,y++); for(int i=0;i<tam;i++) printf(" ");
	gotoxy(x,y); for(int i=0;i<tam;i++) printf(" ");
	colores(ROJO,NEGRO);
	gotoxy(x-2,y+2); for(int i=0;i<tam+4;i++) printf("%c",174);
	do{	rta=getch();}while(rta!='S'&&rta!='s'&&rta!='N'&&rta!='n');
	colores(colorTextoPrevio,colorFondoPrevio);
	system("cls");
	return (rta=='S'||rta=='s');
}

void colores(int texto,int fondo){
	colorTexto = texto; colorFondo = fondo;
	static HANDLE hConsole;
	hConsole = GetStdHandle( STD_OUTPUT_HANDLE );
	SetConsoleTextAttribute( hConsole, fondo*16 + texto); 
}

void gotoxy(int x,int y){
	HANDLE hCon;
	hCon = GetStdHandle(STD_OUTPUT_HANDLE);
	COORD dwPos;
	dwPos.X = x; dwPos.Y = y;
	SetConsoleCursorPosition(hCon, dwPos);
}
int menu_categorias(){ 
	int opcion = 0;
	while (opcion < 1 || opcion > 6){
		colores(BLANCO,NEGRO);
		system("cls");

		SetConsoleTextAttribute(GetStdHandle (STD_OUTPUT_HANDLE), 7);
		for (int i=35; i<=75;i++) { //marco menu
			gotoxy(i,16); printf ("%c",205); //lineas horizontales
			gotoxy(i,28); printf ("%c",205); 
		}
		for (int i=17; i<28; i++) {
			gotoxy (34,i); printf ("%c",186); //lineas verticales 
			gotoxy (75,i);printf ("%c",186);
		}
		gotoxy (34,16); printf ("%c",201); //esquinas
		gotoxy (34,28); printf ("%c",200); 
		gotoxy (75,16); printf ("%c",187); 
		gotoxy (75,28); printf ("%c",188);
		gotoxy (36,17);cout<<"-------- RENOMBRAR CATEGORIAS --------"; 
		for (int j=0; j<5; j++){
			gotoxy (36,19+j);
			cout << (j+1) << "| " << categorias[j] << endl;
		}
		gotoxy (36,25);cout << "6| Salir";
		gotoxy (36,27);cout<<"  Elija una opcion: "; 
		cin >> opcion;
	}
	return opcion;
}
void cambiar_nombre(int opt){ 
	string nombre_nuevo;
		colores(BLANCO,NEGRO);
		system("cls");
		SetConsoleTextAttribute(GetStdHandle (STD_OUTPUT_HANDLE), 7);
		for (int i=35; i<=75;i++) { //marco menu
			gotoxy(i,16); printf ("%c",205); //lineas horizontales
			gotoxy(i,28); printf ("%c",205); 
		}
		for (int i=17; i<28; i++) {
			gotoxy (34,i); printf ("%c",186); //lineas verticales 
			gotoxy (75,i);printf ("%c",186);
		}
		gotoxy (34,16); printf ("%c",201); //esquinas
		gotoxy (34,28); printf ("%c",200); 
		gotoxy (75,16); printf ("%c",187); 
		gotoxy (75,28); printf ("%c",188);
		gotoxy (36,17);cout<<"-------- RENOMBRAR CATEGORIAS --------"; 

			gotoxy (35,20);cout << "Escriba el nuevo nombre de la categoria";

		gotoxy(36,27);cout<<"  NOMBRE: "; 
		cin >> nombre_nuevo;
		ofstream salida;
		salida.open("categorias.txt", ios::out);
		categorias[opt-1]=nombre_nuevo;
		for (int i=0; i<4; i++){
			salida << categorias[i] << endl;
		}
		salida << categorias[4];
}

void imprimirTitulo(string str, int tam){
	int colorTextoPrevio = colorTexto, colorFondoPrevio = colorFondo;
	colores(NEGRO,BLANCO);
	gotoxy(0,1);
	for(int i=0;i<ANCHOPANTALLA;i++) printf(" ");
	colores(CYAN,AZULOSCURO);
	gotoxy(0,2);
	for(int i=0;i<tam+1;i++) printf(" ");
	cout << str;
	for(int i=0;i<tam+1;i++) printf(" ");
	colores(colorTextoPrevio,colorFondoPrevio);
}	
void imprimirDescripcion(){
	int colorTextoPrevio = colorTexto, colorFondoPrevio = colorFondo;
	colores(NEGRO,BLANCO);
	for(int j=3;j<8;j++)
	{
		gotoxy(0,j);
		for(int i=0;i<ANCHOPANTALLA;i++) printf(" ");	
	}
	centrarTexto("Eleg la pregunta que deseas modificar o borrar",5);
	colores(colorTextoPrevio,colorFondoPrevio);
}


void centrarTexto(string linea,int y){
	int tam = linea.length(),x;
	x = (ANCHOPANTALLA - tam)/2;
	gotoxy(x,y);
	printf("%s",linea.c_str());
}
void mostrarPreguntas(){
	bool paginaFinal = false;
	char moverse;
	int arranqueLista =0, max, pos=13;
	string listaDePreguntas [500];
	cargaDePreguntas(matrizPreguntas);
	max = armarListaDePreguntas(listaDePreguntas, matrizPreguntas);
	do{
		system("cls");
		imprimirTitulo("GESTIONAR PREGUNTAS", 40);
		imprimirDescripcion();
		gotoxy(15,9); cout << "PAGINA " + to_string((arranqueLista/30)+1);
		gotoxy(9,11); cout << "id   CATEGORIA                               TEXTO DE PREGUNTA";
		for(int k=arranqueLista ; k<arranqueLista+30 ; k++){
			if (k < max){
			gotoxy(10,13+k-arranqueLista);
			cout << listaDePreguntas[k];
			}else
				paginaFinal = true;
		}
		pos=13;
		gotoxy(5,13); cout << "-->";
		gotoxy(10,45);
		if (paginaFinal == true) cout<<"Presiona <- para ver mas preguntas";
		else if(arranqueLista==0)cout<<"Presiona -> para ver mas preguntas";
		else cout<<"Presiona <- o -> para ver mas preguntas"<< endl;
		do{
			do{
				moverse = getch();
			} while(moverse!=ARRIBA && moverse!=ABAJO && moverse!=DERECHA && moverse!=IZQUIERDA && moverse!=ENTER && moverse!=ESC);
			if(moverse==DERECHA && paginaFinal == false){
				arranqueLista=arranqueLista+30;
			}else if (moverse==IZQUIERDA && arranqueLista!=0){
				arranqueLista=arranqueLista-30;
				paginaFinal=false;
			}else if (moverse==ABAJO && ((paginaFinal==false && pos<43) || (paginaFinal==true && pos <(max%30)+12))){
				gotoxy(5,pos); cout<<"   ";
				pos++;
				gotoxy(5,pos); cout<<"-->";
			}else if (moverse==ARRIBA && pos>13){
				gotoxy(5,pos); cout<<"   ";
				pos--;
				gotoxy(5,pos); cout<<"-->";
			}else if(moverse==ENTER){
				int idPreg = atoi(listaDePreguntas[arranqueLista+pos-13].substr(0,2).c_str());
				int idCat = atoi(listaDePreguntas[arranqueLista+pos-13].substr(3,1).c_str());
				cambiarPregunta(idPreg, idCat, listaDePreguntas);
			}
		} while(moverse!=DERECHA && moverse!=IZQUIERDA && moverse!=ENTER && moverse!=ESC);
	} while (moverse != ESC);
}
	
void cargaDePreguntas(Pregunta matrizPreguntas[][MAX_COL]){
	ifstream  baseDePreguntas;
	int numeroAtributo = 0, idCategoria, idPregunta, numeroGrupo, opcionCorrecta;
	char pregunta[1000], opcion1[1000], opcion2[1000], opcion3[1000], opcion4[1000],entrada[1000];
	baseDePreguntas.open("basepreguntas-nueva.txt");
	if(!baseDePreguntas){
		//Error al abrir el archivo
		cout << "El archivo no puedo ser abierto. Se cerrara el programa." << endl;
		system("pause");
		exit(-1);
	}
	baseDePreguntas.unsetf(ios::skipws);
	while(!baseDePreguntas.eof()){
		if(numeroAtributo == 8 )
			baseDePreguntas.getline(entrada,1000,'\n'); //Consume el \n que hay entre las preguntas, ya que no estan separadas por un arroba
		else{
			baseDePreguntas.getline(entrada,1000,'@');
		}
		switch(numeroAtributo){
		case 0:
			idPregunta = atoi(entrada)-1;
			break;
		case 1:
			idCategoria = atoi(entrada) ;
			break;
		case 2:
			numeroGrupo = atoi(entrada);
			break;
		case 3:
			strcpy(pregunta,entrada);
			break;
		case 4:
			strcpy(opcion1,entrada);
			break;
		case 5:
			strcpy(opcion2,entrada);
			break;
		case 6:
			strcpy(opcion3,entrada);
			break;
		case 7:
			strcpy(opcion4,entrada);
			break;
		case 8:
			opcionCorrecta=atoi(entrada);
			break;
		}
		numeroAtributo++;
		if(numeroAtributo == 9){
			numeroAtributo = 0;
			matrizPreguntas[idCategoria][idPregunta].idCategoria = idCategoria;
			matrizPreguntas[idCategoria][idPregunta].idPregunta = idPregunta;
			matrizPreguntas[idCategoria][idPregunta].numeroGrupo = numeroGrupo;
			matrizPreguntas[idCategoria][idPregunta].pregunta = pregunta;
			matrizPreguntas[idCategoria][idPregunta].opciones[0] = opcion1;
			matrizPreguntas[idCategoria][idPregunta].opciones[1] = opcion2;
			matrizPreguntas[idCategoria][idPregunta].opciones[2] = opcion3;
			matrizPreguntas[idCategoria][idPregunta].opciones[3] = opcion4;
			matrizPreguntas[idCategoria][idPregunta].opcionCorrecta = opcionCorrecta;
		}
	}
}
int armarListaDePreguntas(string listaDePreguntas[], Pregunta matrizPreguntas[][MAX_COL]){
	system("cls");
	int ultimoID, max;
	for(int i=0 ; i< MAX_FILA ; i++){
		ultimoID=-1;
		for(int j=0 ; j < MAX_COL ; j++){
			if (matrizPreguntas[i][j].pregunta != ""){
				if(matrizPreguntas[i][j].idPregunta<10){
					listaDePreguntas[(i*MAX_COL)+j]= "0";
				}else listaDePreguntas[(i*MAX_COL)+j] = "";
				listaDePreguntas[(i*MAX_COL)+j] = listaDePreguntas[(i*MAX_COL)+j] + to_string(matrizPreguntas[i][j].idPregunta)+ "-" + to_string(matrizPreguntas[i][j].idCategoria) + "     " + categorias[matrizPreguntas[i][j].idCategoria]+ "     " + matrizPreguntas[i][j].pregunta.substr(0,60);
				ultimoID = matrizPreguntas[i][j].idPregunta;
				max = ((i*MAX_COL)+j);
			}else{
				if(matrizPreguntas[i][j].idPregunta < 10){
					listaDePreguntas[(i*MAX_COL)+j]= "0";
				}else listaDePreguntas[(i*MAX_COL)+j] = "";
				listaDePreguntas[(i*MAX_COL)+j]= listaDePreguntas[(i*MAX_COL)+j] + to_string(++ultimoID)+ "-" + to_string(i)  + "     " + categorias[i]+ "     " + "PREGUNTA VACIA";
				max = ((i*MAX_COL)+j);
			}
		}
	}
	return max;
}
/*string to_string(int a){
	stringstream ss;
	ss << a;
	string str = ss.str();
	return str;
}*/

void cambiarPregunta(int id, int cat, string listaDePreguntas[]){
	char opt;
	string preguntaNueva = "";
	string opciones[] = {"","","",""};
	system("cls");
	imprimirTitulo("CAMBIAR PREGUNTA", 40);
	if (matrizPreguntas[cat][id].pregunta.length() > 70){
		gotoxy(10,9); cout<<"La pregunta es: " + matrizPreguntas[cat][id].pregunta.substr(0,70);
		gotoxy(10,10); cout<< matrizPreguntas[cat][id].pregunta.substr(70);
	}else{gotoxy(10,9); cout<<"La pregunta es: " + matrizPreguntas[cat][id].pregunta;
	}
	gotoxy(10,11); cout<<"DESEA REESCRIBIRLA? (S/N)";
	do{
		opt = getch();
		opt = toupper(opt);
	} while(opt!='S' && opt!='N');
	if (opt=='S'){
		gotoxy(10,13); cout<<"Reescriba la pregunta por favor: ";gotoxy(10,14); 
		preguntaNueva = escribir(10, 14);
	}
	for (int i=0; i<4; i++){
		if (matrizPreguntas[cat][id].opciones[i].length() >70){
			gotoxy(10,15+(i*3)); cout<<"OPCION "+ to_string(i+1) +":  "+ matrizPreguntas[cat][id].opciones[i].substr(0,70);
			gotoxy(10,15+(i*3)+1); cout<< matrizPreguntas[cat][id].opciones[i].substr(70);
		}else{
		gotoxy(10,15+(i*3)); cout<<"OPCION "+ to_string(i+1) +":  "+ matrizPreguntas[cat][id].opciones[i];
		}
	}
	do{
		if (opt!='S' && opt!='N'){
			gotoxy(10,32); cout<<"                               ";
			gotoxy(10,33);
			for (int i =0 ; i<opciones[opt-'1'].size() ; i++)
				cout<<" ";
			
		}else{
		gotoxy(10,30); cout<<"DESEA REESCRIBIR ALGUNA OPCION? PRESIONE 1/2/3/4 para modificar o 0 para continuar.";
		}
		gotoxy(93,30);
		do{
			opt = getch();
		} while(opt!='0' && opt!='1' && opt!='2' && opt!='3' && opt!='4');
		if (opt!='0'){
			gotoxy(10,32); cout<<"Reescriba la opcion por favor: "; 
			gotoxy(10,33);opciones[opt-'1'] = escribir(10, 33);
			if (opciones[opt-'1'].length() <= 70){
				gotoxy(10,15+(opt-'1')*3); cout<<"OPCION "+ to_string(opt-'0') + ":  " + opciones[opt-'1'];
			}else{
				gotoxy(10,15+(opt-'1')*3); cout<<"OPCION "+ to_string(opt-'0') + ":  " + opciones[opt-'1'].substr(0,70);
				gotoxy(10,15+((opt-'1')*3)+1); cout<<opciones[opt-'1'].substr(70);
			}
		}
	}while(opt!='0');
	gotoxy(10,35); cout<<"INDIQUE CUAL ES LA NUEVA OPCION CORRECTA. PRESIONE 1/2/3/4";
	do{
		opt = getch();
	} while(opt!='1' && opt!='2' && opt!='3' && opt!='4');
	int opcionCorrectaNueva = opt-'0';
	Pregunta nueva = matrizPreguntas[cat][id];
	if (preguntaNueva!="") nueva.pregunta = preguntaNueva;
	else nueva.pregunta = matrizPreguntas[cat][id].pregunta;
	for (int i=0; i<4 ; i++){
		if (opciones[i]!="") nueva.opciones[i] = opciones[i];
		else nueva.opciones[i] = matrizPreguntas[cat][id].opciones[i];
	}
	nueva.opcionCorrecta = opcionCorrectaNueva;
	nueva.idCategoria = cat;
	nueva.idPregunta = id;
	nueva.numeroGrupo = 0;
	matrizPreguntas[cat][id] = nueva;
	if (matrizPreguntas[cat][id].idPregunta < 10){
		listaDePreguntas[(cat*MAX_COL)+id] = "0";
	}else{
		listaDePreguntas[(cat*MAX_COL)+id] = "";
	}
	listaDePreguntas[(cat*MAX_COL)+id] = listaDePreguntas[(cat*MAX_COL)+id] + to_string(matrizPreguntas[cat][id].idPregunta)+ "-" + to_string(matrizPreguntas[cat][id].idCategoria) + "     " + categorias[matrizPreguntas[cat][id].idCategoria]+ "     " + matrizPreguntas[cat][id].pregunta.substr(0,60);
	gotoxy(10,36); cout<<"El cambio fue procesado... Guardando";
	gotoxy(10,38); system("PAUSE");
	string lineas [500];
	int total = cargarLineas(lineas);
	int i = 0, linea = 0;
	bool encontrado = false;
	while (!encontrado){
		if((lineas[i].substr(0,4) == to_string(id+1)+"@"+to_string(cat)) || (lineas[i].substr(0,3) == to_string(id+1)+"@"+to_string(cat))){
			encontrado = true;
			linea = i;
		}
		i++;
	}
	ofstream basePreguntas;
	basePreguntas.open("basepreguntas-nueva.txt");
	i=0;
	if(!basePreguntas){
		//Error al abrir el archivo
		cout << "El archivo no pudo ser abierto. Se cerrara el programa." << endl;
		system("pause");
		exit(-1);
	}else{
		while (i < total){
			if(i != linea){
				basePreguntas << lineas[i]<<endl;
			}else{
				basePreguntas << to_string(nueva.idPregunta+1) + "@" + to_string(nueva.idCategoria) + "@00@\"" + nueva.pregunta +"\"@\""+ nueva.opciones[0] +"\"@\""+ nueva.opciones[1] +"\"@\""+ nueva.opciones[2] +"\"@\""+ nueva.opciones[3] +"\"@"+ to_string(nueva.opcionCorrecta)<<endl;
			}
			i++;
		}
	}
	actualizar_tamanios();
}
	
string escribir (int x, int y){
	string texto ="";
	char letra;
	do{
		do{
			letra = getch();
		} while((letra < 32 && letra!=8 && letra!=13) || (letra > 126 && letra !=168) );
		if(letra!= 8 && letra!=ENTER){
			cout << letra;
			x++;
			texto += letra;
		}else if (letra==8){
			x--;
			gotoxy(x,y);
			cout << " ";
			gotoxy(x,y);
			texto = texto.substr(0,texto.size()-1);
		}
	}while(letra!=ENTER);
	return texto;
}
int cargarLineas (string lineas[]){
	ifstream  base;
	int i =0;
	base.open("basepreguntas-nueva.txt");
	if(!base){
		//Error al abrir el archivo
		cout << "El archivo no puedo ser abierto. Se cerrara el programa." << endl;
		system("pause");
		exit(-1);
	}
	while(!base.eof()){
		getline(base,lineas[i]);
		i++;
	}
	return i;
}
void actualizar_tamanios(){
	system("cls");
	int tamanios_nuevos[5] = {0,0,0,0,0}, j;
	bool parate;
	for (int i=0; i<5; i++){
		parate = false;
		j=0;
		while(!parate && j < 87){
			if (matrizPreguntas[i][j].pregunta != ""){
				tamanios_nuevos[i]++;
				j++;
			}else
				parate =true;
		}
	}
	for (int i = 0 ; i<5 ; i++){
		tamanoCategorias[i] = tamanios_nuevos[i];
	}
	for (int i = 0 ; i<5 ; i++){
		cout << categorias[i] << " " << tamanios_nuevos [i] << endl;
	}
	system("PAUSE");
	ofstream salida;
	salida.open("categorias.txt", ios::out);
	for (int i=0; i<4; i++){
		salida << categorias[i] << " " << tamanoCategorias[i] << " ";
	}
	salida << categorias[4] << " " << tamanoCategorias[4];
}
void importarPreguntas(){
}
