#include <stdio.h>
#include <windows.h>
#include <conio.h>
#include <iostream>
#include <ctime>
#include <string>
#include <fstream>
#include <cmath>
#include <iomanip>
#include <cstdlib>

#define MAX_FILA 5
#define MAX_COL 88
#define T 100
#define nn 164 // minuscula
#define NN 165 // mayuscula
#define ENTER 13
#define BORRAR 8
#define ARRIBA 72
#define IZQUIERDA 75
#define ABAJO 80
#define DERECHA 77


using namespace std;
struct Pregunta {
	int idCategoria;    
	int idPregunta;
	int numeroGrupo;
	string pregunta;
	string opciones[4];
	int opcionCorrecta;    //Subndice de la opcin correcta.
}; 
struct fecha {
	int anio, mes, dia, hora, mins, segs;
};
struct usuario {
	int id;
	string nombre;
	string clave;
};
struct jugada {
	long idPartida;
	int idUsr;
	bool rtas[10];
	int puntaje;
};
struct partida{
	long idPartida;
	int idUI;
	int idUO;
	int categorias[10];
	int preguntas[10];
	int estado; //Este campo ha sido agregado por el grupo
};
struct Nodo {
	int id;
	int idPartida;
	struct Nodo * sig;
};
struct Nodo2 {
	struct partida info;
	int id;
	struct Nodo2 * sig;
	struct Nodo2 * ant;
};
struct preferencias{
	int color;
	int creditos;
	int id;
	fecha ultimaConexion;
	bool fondo; // rewards[6];
	int genero; //0 no define || 1 varon || 2 mujer
};
int Menu(void);
void Seguridad_menu(void);
void logo(int,int);
void pintar_logo(void);
void borrar_logo(void);
void mover_logo(void);
void gotoxy(int,int);
void Color(int color);
void MostrarCursor(bool);
void carga(int&,int&);
void transicion(bool);
int IniciarRegistrar_menu(void);
int ruleta(int x, int y);
int pregunta(int a);
void menu_dibujos(void);
void Nombrar_partida(long&,int&);
void menu_mensajes(void);
void borrar_dibujo(void);
void jugar_dibujo(void);
void stats_dibujo(void);
void micuenta_dibujo(void);
void iniciadas_dibujo(void);
void pendiente_dibujo(void);
void terminadas_dibujo(void);
void opciones_dibujo(void);
void cerrar_dibujo(void);
void salir_dibujo(void);
void pintar_cuadrito(int,int);
void borrar_cuadrito(int,int);
void mover_cuadrito(void);
void Encriptar_pass(void);
void Validar_pass(void);
void Paleta_colores(bool);
void validar_salida(void);
bool registrar_userp(void);
bool User(void);
bool registrar_user(void);
bool mover_flechita(void);
bool Color_fuente(void);
bool menu_opciones(void);
bool generar_capcha(bool&,int&);
int Numero_random(void);
void mostrar_globales(void);
void Seleccion_categoria(int& a);
void obtenerFechaActual(fecha & f);
bool obtenerIdUsuario(int & id);
bool registrarUsuario(usuario usr);
bool buscarXIdUsuario(int id, usuario & usr);
bool buscarXNombreUsuario(string nombre, usuario & usr);
void cargaDePreguntas(Pregunta matrizPreguntas[][MAX_COL]);
void grilla(int,int);
void Jugar_partida(partida&,jugada&,int&,bool);
void grilla(int,int,bool);
void marcarGrilla(bool,int&);
void guardar_partidas(partida& pendiente);
bool leer_iniciadas(void);
bool leer_terminadas(void);
void guardar_jugadas(jugada& pendiente);
void leer_jugadas(jugada& r, partida& actual, bool abre);
void marcarGrillaOponente(bool []);
int imprimir_opcion(string,int,int);
int controlar_iniciadas(int,bool);
int contador_jugadores(void);
void dibujar_ruleta_marco(int x1, int y1,int a);
void dibujar_ruleta_relleno(int x1, int y1,int a);
int corona_menu(void);
void corona_dibujo(void);
int ruleta_provisional(void);
void imprimir_grilla_de_partidas(int,int,int);
int seleccion_partidas(int,int,Nodo2 *, int,bool);
bool leer_pendientes(partida&);
void imprimir_pagina_partidas(Nodo2 *,int);
void pintar_cuadrito2(int,int);
bool calcular_stats();
void imprimir_stats(Nodo*,int&,int&,int&,int&,int&,int&,int[]);
bool procesar_stats(Nodo*,int&,int&,int&,int&,int&,int&,int[]);
long actualizarConexion(void);//Esta funcion devolvera un long con la fecha y hora actual
void micuenta(void);//Esta funcion revisara mostrara el menu mi cuenta, logros y creditos
bool cargarPreferencias(preferencias&);
bool guardar_preferencias(preferencias);
void emparejar_preferencias(void);
void mostrar_creditos(int x1,int y1);
bool buscar_preferencias(int,preferencias&);
bool actualizar_creditos(int,bool,int);
bool comprobar_creditos(int);
void pintar_cuadrado_color(int,int,int);
void actualizar_ids(void);
void imprimir_ficha(int,int,int);
void Jugar_vs_com(jugada,partida);
bool control_de_usuario();
bool control_de_contrasena();
void guardar_usuario();
bool registrar_usuarios();
string ExePath();
void Seleccionar_fondo();
void ayudita(int);
void cargarCategorias();

string user,userp,Global_captcha;
int Global_a=0,Global_guia=0,x=0,y=0,Cant_cuentas=0,ids;
//string CUENTAS[100], CONTRASENAS[100];
bool Global_b=false,SALIDA=false,registrado=false, debug=false, delcinignore=false;
const char * archUsuarios="usuarios.txt";
const char * archPartida="Partidas.dat";
const char * archJugada="Jugadas.dat";
const char * archPreferencias="Preferencias.dat";
string categorias [5];
int tamanoCategorias[5];
int Global_contador=0;
int A[100];
int B[100];
usuario usuarioActual;
preferencias preferenciasActual;
Pregunta matrizPreguntas[MAX_FILA][MAX_COL];



/* 

x --> Coordenada generica de absisas
y --> Coordenada generica de ordenadas
Global_a --> se encarga normalmente de la suma de coordenadas para luego tomar decisiones segun su posicion
Global_guia -->se va a usar para ir marcando el "momento" en donde se encuentra el programa
Global_b --> Usado para que condiciones de comenzar/acabar bucles y para deshabilitar if
Cant_cuentas --> Usado como sub indice y contador de cuentas registradas
SALIDA Usado para terminar el bucle de main y poder salir

*/

std::string getFileContents (std::ifstream&);            //Gets file contents

int main(void) {
	srand(time(NULL));
	system("mode con: cols=80 lines=40"); //Tamao de consola 80x40, forma cuadrada
	/*
	CUENTAS[0]="DEFAULT"; //Se genera una cuenta default libre de toda regla para evitar hacer cuentas cada vez que se ejecuta
	CONTRASENAS[0]="DEFAULT";
	Cant_cuentas=0;//la cantidad de cuentas aumenta en 1
	*/
	MostrarCursor(false);
	system("cls");
	cargarCategorias();
	system("COLOR F0");
	
	actualizar_ids();
	
	preferenciasActual.color=240;
	preferenciasActual.fondo=false;
	
	if(debug==false){	
		logo(13,4);	
		x=0;y=15;
		pintar_logo(); 	
		mover_logo();
		gotoxy(20,10);system("PAUSE");
		transicion(true);
	}
	
	while (registrado==false){
		IniciarRegistrar_menu();
	}
	
	while(SALIDA==false){
		Menu();
		Color(240);
		transicion(true);
		do{
			IniciarRegistrar_menu();
		}while (registrado==false);
	}
	
	system("cls");
	gotoxy(0,0);
	cout<<"Te vamos a extra"<<(char)nn<<"ar :'("<<endl;
	system("PAUSE");
	
	return 0;
	
	}
	
int IniciarRegistrar_menu(void){//Iniciar sesion - Registrarse - Salir
	transicion(false);
	Global_guia=0;
	registrado=false;
	
	bool v;
	
	gotoxy(8,5);cout<<"INICIA SESION";
	gotoxy(8,8);cout<<"REGISTRATE";
	gotoxy(8,11);cout<<"SALIR";
	
	pintar_cuadrito(7,4);
	Global_b=false;
	
	while(Global_b==false){ 
		mover_cuadrito();
		Sleep(30);
		if (Global_b==true){
			switch (Global_a){
			case 11:{//iniciar sesion
				Validar_pass();
				break;
			}
			case 14:{ //registrarse
				registrar_usuarios();
				return 1;
				break;
			}
			case 17:{
				validar_salida();
			}
			}
		}
	}
	return 1;
}
void Validar_pass(void){ //Se pedira usuario,contrasea,controlar contrasea, pedir un capcha temporalmente
	transicion(false);
	MostrarCursor(true);
	
	bool UserAproved=false,banderita=false;
	int Centinela=3;//Da X intentos de colocar contrasea
	
	while(UserAproved!=true){//La idea de esto es que se apruebe el usuario o que tenga X intentos
		UserAproved=User();
		if (UserAproved!=true){
			gotoxy(28,6);
			cout<<"                         ";
			gotoxy(15,10);
			cout<<"Error de usuario/contrasena. ";
			Centinela = Centinela-1;
			cout<<"Intentos restantes: "<<Centinela;
			if (((Centinela==0)&&(banderita==true))||(SALIDA==true)){
				SALIDA=true;
				UserAproved=1;
				Seguridad_menu();
			}
			if ((Centinela==0)&&(banderita==false)){//Aca se pide un capcha, esta en desarrollo**
				transicion(false);
				gotoxy(2,2);
				gotoxy(4,10);
				Global_b = generar_capcha(banderita,Centinela);
				if (Global_b==true)	Centinela=3;
				else {UserAproved=true;Global_b=true;SALIDA=true;}
				transicion(false);
			}
		}
	}
	registrado=true;
	MostrarCursor(false);
}
bool User(void){ //Esta funcion toma un usuario, la contrasea y la encripta visualmente (se modifican globales "user" y "userp")
	bool pifie = false;
	usuario check;
	gotoxy(8,5);
	cout<<"                                    ";
	gotoxy(8,5);
	cout<<"INGRESE USUARIO: ";
	cin>>ws>>usuarioActual.nombre;
	gotoxy(8,6);
	cout<<"                                    ";
	if (!buscarXNombreUsuario(usuarioActual.nombre, check)){
		pifie = true;
	}
	gotoxy(8,6);
	cout<<"INGRESE CONTRASENA: "; 
	gotoxy(28,6);
	
	Encriptar_pass();
	
	if(check.clave == usuarioActual.clave && pifie == false){
		usuarioActual.id = check.id;
		return true;
	}
	return false;
}
void Encriptar_pass(void){//Este proceso toma caracteres, modifica "userp" e imprime "*"
	char aux;
	int auxa=28;
	usuarioActual.clave="";
	do{
		aux=getch();
		size_t tam= usuarioActual.clave.length(); //obtenemos el tamao del string
		if (aux==BORRAR){ //Si se oprime "delete" se podra borrar caracteres del pass
			if (tam>0){
				usuarioActual.clave.erase(tam-1);  //a userp se le borra el caracter en  (tam - 1)
				auxa--;
				gotoxy ((auxa),6); printf(" ");
			}		
		}else{
			if(aux!=ENTER){
				gotoxy (auxa,6); printf("*");
				usuarioActual.clave = usuarioActual.clave + aux;
				auxa++;
			}
		}	
		
	}while (aux!=ENTER);
}
int Menu(void){//Imprime menu principal, modifica Global_guia=1
	transicion(false);
	Global_guia=1;
	menu_mensajes();
	bool Seleccion_cuadro = false;
	Global_b=false;
	emparejar_preferencias();
	jugar_dibujo();
	int aux;
	do{ 
		mover_cuadrito();
		Sleep(30); 
		if (Global_b==false)menu_dibujos();
		if (Global_b==true){
			switch (Global_a){
			case 36:{//Jugar
				transicion(false);
				gotoxy(29,18);cout<<"Preparate para empezar!";
				int b=9;
				while(b>=0){//Este while solo contara regresivamente antes de comenzar la partida
					Color(252-b);
					pintar_cuadrito(32,19);
					gotoxy(39,20);Color(252-b);
					if (b==0)cout<<"!";
					else cout<<b;
					b--;
					Sleep(1000);
				}
				Color(240);
				transicion(false);
				jugada RuedaPreguntas;
				partida Nueva;
				Nueva.estado=0; //Este estado indica que ha sido iniciada y quedara como pendiente
				Nueva.idUI = usuarioActual.id;
				RuedaPreguntas.puntaje=0;
				Nombrar_partida(RuedaPreguntas.idPartida,Nueva.idUO);
				Nueva.idPartida=RuedaPreguntas.idPartida;
				//Aca se hacen las 10 preguntas
				do{
					Jugar_partida(Nueva,RuedaPreguntas,aux,true);
					Global_contador++;
				} while(Global_contador!=10);
				y=9;x=36;Global_guia=1;
				transicion(true);
				/*
				Aca habia una serie de renglones donde te decian que preguntas de que categoria te habian tocado
				*/
				for (int i=0;i<10;i++){
					gotoxy(20,22+i);
					cout<<i+1<<") "<<"La " <<B[i] <<(char)248<<" pregunta de la categor"<<(char)161<<"a "<<A[i] <<".";					
					Nueva.preguntas[i]=B[i];
					Nueva.categorias[i]=A[i];
				}
				
				if (Nueva.idUO == usuarioActual.id){
					Jugar_vs_com(RuedaPreguntas,Nueva);
				}
				else{
					grilla(4,10,false);
					for(int qwe=0;qwe<10;qwe++){
						gotoxy((8+(7*qwe)),13);
						if (RuedaPreguntas.rtas[qwe] == true){
							Color(250);
							cout<<(char)251;
						}else{
							Color(252);
							cout<<"x";
						}
					}
					Color(240);
					gotoxy(10,18); 
					cout<<"Tu puntaje final es: "<<RuedaPreguntas.puntaje<<". Tuviste un "<<RuedaPreguntas.puntaje*10/3<<"% de acierto! :D";
					guardar_jugadas(RuedaPreguntas);
					guardar_partidas(Nueva);
					guardar_preferencias(preferenciasActual);
				}
				Global_contador=0;
				gotoxy(3,2);Color(241);system("PAUSE");Color(240);
				menu_mensajes();
				Global_a=33;
				menu_dibujos();
				Global_b=false;
				break;}
			case 38:{//Cerrar Sesion
				guardar_preferencias(preferenciasActual);
				preferenciasActual.color=240;
				preferenciasActual.fondo=false;
				return 2;
				break;
			} 
			case 65:{ //opciones
				Seleccion_cuadro=Global_b;
				if (Seleccion_cuadro==true){
				do{
					Global_b=menu_opciones();
				}while(Global_b==false);
				transicion(true);
				Seleccion_cuadro=false;
				x=9;y=23;
				menu_mensajes();
				Global_a=33;
				menu_dibujos();
				Global_b=false;
				}
				break;
			}
			case 40:{//mi cuenta
				transicion(false);
				micuenta();
				transicion(false);
				Seleccion_cuadro=false;
				x=9;y=23;
				menu_mensajes();
				Global_a=33;
				menu_dibujos();
				Global_b=false;
				break;
			}
			case 42:{ //Pendientes
				transicion(false);
				partida Pendiente;
				jugada RuedaPreguntas, Terminada;
				preferencias Preferencias_para_guardar;
				bool asd=leer_pendientes(Pendiente);
				if (asd){
					RuedaPreguntas.puntaje=0;
					transicion(true);
					leer_jugadas(Terminada,Pendiente,false); //Tomara la partida ya jugada a partir de la id de la jugada pendiente ya seleccionada
					gotoxy(29,18);cout<<"Preparate para empezar!";
					int b=9;
					while(b>=0){//Este while solo contara regresivamente antes de comenzar la partida
						Color(252-b);
						pintar_cuadrito(32,19);
						gotoxy(39,20);Color(252-b);
						if (b==0)cout<<"!";
						else cout<<b;
						b--;
						Sleep(1000);
					}
					Color(240);
					transicion(false);
					grilla(4,30,true);
					marcarGrillaOponente(Terminada.rtas); //Pasamos el array entero 
					Global_contador=0;
					do{ //Esto es exactamente lo mismo que se hace en case 36 pero sin hacer la ruleta
						Jugar_partida(Pendiente,RuedaPreguntas,aux,false);
						Global_contador++;
					} while(Global_contador!=10);
					transicion(false);
					grilla(4,10,true);
					for(int qwe=0;qwe<10;qwe++){
						gotoxy((8+(7*qwe)),13);
						if (RuedaPreguntas.rtas[qwe] == true){
							Color(250);
							cout<<(char)251;
						}else{
							Color(252);
							cout<<"x";
						}
						gotoxy((8+(7*qwe)),15);
						if (Terminada.rtas[qwe] == true){
							Color(250);
							cout<<(char)251;
						}else{
							Color(252);
							cout<<"x";
						}
					}
					gotoxy(10,21); cout<<"Tu puntaje final es: "<<RuedaPreguntas.puntaje<<".";
					gotoxy(5,23);  cout<<"Tuviste un "<<RuedaPreguntas.puntaje*10/3<<"% de acierto vs un "<<Terminada.puntaje*10/3<<"% del oponente";
					if (RuedaPreguntas.puntaje < Terminada.puntaje){ //Iniciador gana
						Color(252); gotoxy(15,26); cout<<"Perdiste!";Color(240);
						actualizar_creditos(10,true,Terminada.idUsr);
						Pendiente.estado = 1;
					}else if (RuedaPreguntas.puntaje > Terminada.puntaje){ //Iniciador pierde
						Color(250); gotoxy(15,26); cout<<"Ganaste!";Color(240);
						actualizar_creditos(10,true,RuedaPreguntas.idUsr);
						Pendiente.estado = 2;
					}else if (RuedaPreguntas.puntaje == Terminada.puntaje ) { //Se se empata
						Color(249); gotoxy(15,26); cout<<"Empate!";Color(240);
						actualizar_creditos(4,true,Terminada.idUsr);
						actualizar_creditos(4,true,RuedaPreguntas.idUsr);
						Pendiente.estado = 3;
					}
					gotoxy(3,2);Color(249);cout<<"[Los creditos ya se han guardado]";
					guardar_jugadas(RuedaPreguntas);
					guardar_partidas(Pendiente);
					gotoxy(5,30);Color(241);system("PAUSE");Color(240);
				}
				transicion(true);
				Seleccion_cuadro=false;
				x=9;y=23;
				menu_mensajes();
				Global_a=33;
				menu_dibujos();
				Global_b=false;
				break;
			}
			case 69:{ //Terminadas
				transicion(false);
				leer_terminadas();
				transicion(false);
				Seleccion_cuadro=false;
				x=9;y=23;
				menu_mensajes();
				Global_a=33;
				menu_dibujos();
				Global_b=false;
				break;
			}
			case 67:{ //Iniciadas
				transicion(false);
				leer_iniciadas();
				transicion(false);
				Seleccion_cuadro=false;
				x=9;y=23;
				menu_mensajes();
				Global_a=33;
				menu_dibujos();
				Global_b=false;
				break;
			}
			case 63:{ //Mis stats
				transicion(false);
				calcular_stats();
				getch();
				transicion(false);
				Seleccion_cuadro=false;
				x=9;y=23;
				menu_mensajes();
				Global_a=33;
				menu_dibujos();
				Global_b=false;
				break;
			}
			default:{
				gotoxy(15,15);
				cout<<"FUNCIONALIDAD EN DESARROLLO";
				break;}
			}
			jugar_dibujo();
		}
	}while(Seleccion_cuadro==false);
	return 2;
}
void menu_dibujos(void){ //se deriva a los dibujitos del menu
	borrar_dibujo();
	switch(Global_a){
	case 36:{jugar_dibujo();break;}
	case 38:{cerrar_dibujo();break;}
	case 65:{salir_dibujo();break;}
	case 63:{stats_dibujo();break;}
	case 40:{micuenta_dibujo();break;}
	case 67:{iniciadas_dibujo();break;}
	case 42:{pendiente_dibujo();break;}
	case 69:{terminadas_dibujo();break;}
	}
	}
void jugar_dibujo(void){
	gotoxy(0,5);
	string Directorio = ExePath() , archPruebita = "Joystick.txt" , carpeta = "Dibujos" ;
	Directorio = Directorio + (char)92 + carpeta + (char)92 + archPruebita;
	const char * Directorioconstante = Directorio.data();
	
	std::ifstream Reader (Directorioconstante);             //Open file
	std::string Art = getFileContents (Reader);       //Get file
	std::cout << Art << std::endl;               //Print it to the screen
	Reader.close ();                           //Close file

	
}
void pendiente_dibujo(void){
	string Directorio = ExePath() , archPruebita = "pendiente.txt" , carpeta = "Dibujos" ;
	Directorio = Directorio + (char)92 + carpeta + (char)92 + archPruebita;
	const char * Directorioconstante = Directorio.data();
	
	gotoxy(0,5);
	std::ifstream Reader (Directorioconstante);             //Open file
	std::string Art = getFileContents (Reader);       //Get file
	std::cout << Art << std::endl;               //Print it to the screen
	Reader.close ();                           //Close file
	
}
void terminadas_dibujo(void){
	string Directorio = ExePath() , archPruebita = "oponente.txt" , carpeta = "Dibujos" ;
	Directorio = Directorio + (char)92 + carpeta + (char)92 + archPruebita;
	const char * Directorioconstante = Directorio.data();
	
	gotoxy(0,5);
	std::ifstream Reader (Directorioconstante);             //Open file
	std::string Art = getFileContents (Reader);       //Get file
	std::cout << Art << std::endl;               //Print it to the screen
	Reader.close ();                           //Close file
	
}
void iniciadas_dibujo(void){
	string Directorio = ExePath() , archPruebita = "iniciadas.txt" , carpeta = "Dibujos" ;
	Directorio = Directorio + (char)92 + carpeta + (char)92 + archPruebita;
	const char * Directorioconstante = Directorio.data();
	
	gotoxy(0,5);
	std::ifstream Reader (Directorioconstante);             //Open file
	std::string Art = getFileContents (Reader);       //Get file
	std::cout << Art << std::endl;               //Print it to the screen
	Reader.close ();                           //Close file
	
}
void micuenta_dibujo(void){
	string Directorio = ExePath() , archPruebita = "micuenta.txt" , carpeta = "Dibujos" ;
	Directorio = Directorio + (char)92 + carpeta + (char)92 + archPruebita;
	const char * Directorioconstante = Directorio.data();
	
	gotoxy(0,5);
	std::ifstream Reader (Directorioconstante);             //Open file
	std::string Art = getFileContents (Reader);       //Get file
	std::cout << Art << std::endl;               //Print it to the screen
	Reader.close ();                           //Close file
	
}
void stats_dibujo(void){
	string Directorio = ExePath() , archPruebita = "Calculadora.txt" , carpeta = "Dibujos" ;
	Directorio = Directorio + (char)92 + carpeta + (char)92 + archPruebita;
	const char * Directorioconstante = Directorio.data();
	
	gotoxy(0,5);
	std::ifstream Reader (Directorioconstante);             //Open file
	std::string Art = getFileContents (Reader);       //Get file
	std::cout << Art << std::endl;               //Print it to the screen
	Reader.close ();                           //Close file
	
}
void borrar_dibujo(void){
	for (int i=2;i<=15;i++){
	gotoxy(5,i);
	cout<<"                                                                    ";
	}
	
	}

void cerrar_dibujo(void){
	string Directorio = ExePath() , archPruebita = "Llave.txt" , carpeta = "Dibujos" ;
	Directorio = Directorio + (char)92 + carpeta + (char)92 + archPruebita;
	const char * Directorioconstante = Directorio.data();
	
	gotoxy(0,5);
	std::ifstream Reader (Directorioconstante);             //Open file
	std::string Art = getFileContents (Reader);       //Get file
	std::cout << Art << std::endl;               //Print it to the screen
	Reader.close ();                           //Close file

}
void salir_dibujo(void){
	string Directorio = ExePath() , archPruebita = "Cama.txt" , carpeta = "Dibujos" ;
	Directorio = Directorio + (char)92 + carpeta + (char)92 + archPruebita;
	const char * Directorioconstante = Directorio.data();
	
	gotoxy(0,5);
	std::ifstream Reader (Directorioconstante);             //Open file
	std::string Art = getFileContents (Reader);       //Get file
	std::cout << Art << std::endl;               //Print it to the screen
	Reader.close ();                           //Close file
	
}
void transicion(bool z){//Usada para crear marco de UTN, segun el bool se hara toda la animacion o instantaneo
	gotoxy(0,0);
	Color(preferenciasActual.color);
	if (z==true){
		for (int a=0;a<=39;a++){
			gotoxy(0,a);
			cout<<"UTN UTN UTN UTN UTN UTN UTN UTN UTN UTN UTN UTN UTN UTN UTN UTN UTN UTN UTN UTN ";
			Sleep(30);
		}
		for (int a=1;a<=38;a++){
			gotoxy(3,a);
			cout<<"                                                                        ";
			Sleep(30);
			
		}
	}else{
		gotoxy(0,0);cout<<"UTN UTN UTN UTN UTN UTN UTN UTN UTN UTN UTN UTN UTN UTN UTN UTN UTN UTN UTN UTN ";
		for(int a=1;a<=38;a++){
			gotoxy(0,a);
			cout<<"UTN                                                                         UTN ";
		}
		gotoxy(0,39);cout<<"UTN UTN UTN UTN UTN UTN UTN UTN UTN UTN UTN UTN UTN UTN UTN UTN UTN UTN UTN UTN";
	}
	Color(240);
	gotoxy(0,0);
	
}
void carga(int& c,int & b){//Arma la barra de carga, agrega comentarios, muestra porcentaje de carga
	c++;
	gotoxy(c,b); 
	Color(249);
	printf("%c",219);
	gotoxy(5,38);		
	switch (c){
	case 6:{
		printf("COMENZANDO LA CARGA        ");
	}break;
	case 28:{
		printf("SEGUIMOS CARGANDO...       ");
	}break;
	case 43:{
		printf("YA TERMINA DE CARGAAR! :D");
	}break;
	case 62:{
		printf("LISTOOO!! :P              ");
	}break;
	}
	Sleep(2*c);//mientras mas coordenada X(c) mas tiempo Sleep hay
}
void pintar_logo(void){//Imprime logo UTN grande 21x7
	
	Color(249);
	gotoxy(x,y);   printf("%c%c  %c%c  %c%c%c%c%c  %c%c  %c%c",219,219,219,219,219,219,219,219,219,219,219,219,219); //el %c hace referencia a un caracter
	gotoxy(x,y+1); printf("%c%c  %c%c  %c%c%c%c%c  %c%c  %c%c",219,219,219,219,219,219,219,219,219,219,219,219,219);
	gotoxy(x,y+2); printf("%c%c  %c%c    %c    %c%c%c %c%c",219,219,219,219,219,219,219,219,219,219);
	gotoxy(x,y+3); printf("%c%c  %c%c    %c    %c%c %c%c%c",219,219,219,219,219,219,219,219,219,219);
	gotoxy(x,y+4); printf("%c%c  %c%c    %c    %c%c  %c%c",219,219,219,219,219,219,219,219,219);
	gotoxy(x,y+5); printf("%c%c  %c%c    %c    %c%c  %c%c",219,219,219,219,219,219,219,219,219);
	gotoxy(x,y+6); printf("%c%c%c%c%c%c    %c    %c%c  %c%c",219,219,219,219,219,219,219,219,219,219,219);
	
}
void borrar_logo(void){//Imprime vacio en el UTN anterior 21x7
	Color(240);
	gotoxy(x,y);   printf("                     ");
	gotoxy(x,y+1); printf("                     ");
	gotoxy(x,y+2); printf("                     ");
	gotoxy(x,y+3); printf("                     ");
	gotoxy(x,y+4); printf("                     ");
	gotoxy(x,y+5); printf("                     ");
	gotoxy(x,y+6); printf("                     ");
}
void mover_logo(void){//Mueve el UTN grande hasta un punto y luego imprime la barra de carga
	int b,c;
	c=4;
	b=37;
	do{
		if(x<29){
			borrar_logo();
			x++;
			pintar_logo();
			carga(c,b);
		}else{
		if (y>=3){
			borrar_logo();
			y--;
			pintar_logo();
			carga(c,b);
		}else{
			carga(c,b);
		}}
		Sleep(c);
		gotoxy(70,36);
		cout<<(c*100)/74<<"%";
		gotoxy(1,1);
	}while (c!=74);
	Color(240);
}

void logo(int x,int y){// aca se imprime el PREG______ADOS y los integrantes del grupo
	//53[L]x5[H]
	gotoxy(x,y);   printf("%c%c%c %c%c%c %c%c%c %c%c%c                       %c%c%c %c%c  %c%c%c %c%c%c",219,219,219,219,219,219,219,219,219,219,219,219,219,219,219,219,219,219,219,219,219,219,219);
	gotoxy(x,y+1); printf("%c %c %c %c %c   %c                         %c %c %c %c %c %c %c",219,219,219,219,219,219,219,219,219,219,219,219,219);
	gotoxy(x,y+2); printf("%c%c%c %c%c%c %c%c  %c                         %c%c%c %c %c %c %c %c%c%c",219,219,219,219,219,219,219,219,219,219,219,219,219,219,219,219,219,219,219);
	gotoxy(x,y+3); printf("%c   %c%c  %c   %c %c                       %c %c %c %c %c %c   %c",219,219,219,219,219,219,219,219,219,219,219,219,219);
	gotoxy(x,y+4); printf("%c   %c %c %c%c%c %c%c%c                       %c %c %c%c  %c%c%c %c%c%c",219,219,219,219,219,219,219,219,219,219,219,219,219,219,219,219,219,219,219);

	gotoxy(7,24);cout<<"pregUTNados - V 1.04";
	gotoxy(7,26);cout<<"    Contursi Damian  -     dcontursi@gmail.com     - UTN FRSF";
	gotoxy(7,28);cout<<"    Hauque Federico  -      haucheee@yahoo.ca      - UTN FRSF";
	gotoxy(7,30);cout<<"    Saudejaud German - germansaudejaud@hotmail.com - UTN FRSF";
}
void MostrarCursor(bool a){//Este proceso oculta el cursor
	//Si a es true sera visible, de lo contrario no
	HANDLE hCon;
	hCon = GetStdHandle(STD_OUTPUT_HANDLE);
	CONSOLE_CURSOR_INFO cci; //cci va a ser un cursor
	cci.dwSize = 100;//variable de 1-100 cada numero representa cursor distinto
	
	if (a==true)cci.bVisible = TRUE; //se debe usar mayus 
	else cci.bVisible = FALSE;
	
	SetConsoleCursorInfo(hCon,&cci);//se pasa el cursor por referencia
	
}
void gotoxy(int x1,int y1){//esta funcion posiciona el cursor en una posicion x,y
	//Esta funcin posiciona el cursor en las coordenadas indicadas
	HANDLE hCon; //Handle es un puntero que puede mover bloques de memoria
	hCon = GetStdHandle(STD_OUTPUT_HANDLE);
	COORD dwPos;
	dwPos.X = x1;
	dwPos.Y = y1;
	
	SetConsoleCursorPosition(hCon, dwPos);
}
void Color(int color){//Esta funcion cambia de colores la salida de texto, todavia no implementada
	if (preferenciasActual.fondo == true){
		if(color == 240){
			color = color - 255;
		}else{
			color = color - 240;
		}
	}
	static HANDLE hConsole;
	hConsole = GetStdHandle( STD_OUTPUT_HANDLE );
	SetConsoleTextAttribute( hConsole, color | (0 * 0x10 + 0x100 ) ); 
}
int Numero_random(void){//esta funcion cambia semilla genera un numero random 
	
	int a=rand();
	return a;
}
std::string getFileContents (std::ifstream& File){
	std::string Lines = "";        //All lines
	
	if (File)                      //Check if everything is good
	{
		while (File.good ())
		{
			std::string TempLine;                  //Temp line
			std::getline (File , TempLine);        //Get temp line
			TempLine += "\n";                      //Add newline character
			
			Lines += TempLine;                     //Add newline
		}
		return Lines;
	}
	else                           //Return error
		{
			return "ERROR File does not exist.";
		}
}
void pintar_cuadrito(int a, int b){//se pinta un cuadro de 15x3
	x=a;y=b;
	gotoxy(x,y); printf("%c%c%c%c%c%c%c%c%c%c%c%c%c%c%c",201,205,205,205,205,205,205,205,205,205,205,205,205,205,187);
	gotoxy(x,y+1); printf("%c",186);gotoxy(x+14,y+1);printf("%c",186);
	gotoxy(x,y+2); printf("%c%c%c%c%c%c%c%c%c%c%c%c%c%c%c",200,205,205,205,205,205,205,205,205,205,205,205,205,205,188);
}
void borrar_cuadrito(int a, int b){//se borra un cuadro de 15x3
	x=a;y=b;
	gotoxy(x,y); printf("               ");
	gotoxy(x,y+1); printf(" ");gotoxy(x+14,y+1);printf(" ");
	gotoxy(x,y+2); printf("               ");
}
void mover_cuadrito(void){//borra el cuadro, cambia x e y, imprime el cuadro
	mostrar_globales();
	char tecla = getch(); //Asigna a tecla el caracter
		gotoxy(x,y);
		
		borrar_cuadrito(x,y);
		switch (Global_guia){//ponemos un switch para poder reciclar el Cuadrito
		case 0://Usado en el inicio sesion/registrarse
			if (tecla == ENTER){ Global_b=true;}
			if ((tecla == ARRIBA)&&(y==7)){ y=4;Global_b=false;}
			if ((tecla == ABAJO)&&(y==7)){ y=10;Global_b=false;}
			if ((tecla == ARRIBA)&&(y==10)){ y=7;Global_b=false;}
			if ((tecla == ABAJO)&&(y==4)){ y=7;Global_b=false;}
			break;
		case 1://Usado en el menu Jugar/Stats/CerrarSesion/Opciones
			{
			if (tecla == ENTER){ Global_b=true;}
			if ((tecla == IZQUIERDA)&&(x==36)){ x=9;Global_b=false;}
			if ((tecla == DERECHA)&&(x==9)){ x=36;Global_b=false;}
			
			if (tecla == ARRIBA){
				switch (y){
				case 29:{ y=27;Global_b=false;break;}
				case 31:{ y=29;Global_b=false;break;}
				case 33:{ y=31;Global_b=false;break;}
				}
			}
			if (tecla == ABAJO){
				switch(y){
				case 31:{ y=33;Global_b=false;break;}
				case 29:{ y=31;Global_b=false;break;}			
				case 27:{ y=29;Global_b=false;break;}
				}
			}
			
			break;
		}
		case 2: //Usado al momento de querer salir de la aplicacion
			{
				if (tecla == ENTER){ Global_b=true;}
				if ((tecla == IZQUIERDA)&&(x==40)){ x=20;Global_b=false;}
				if ((tecla == DERECHA)&&(x==20)){ x=40;Global_b=false;}
			}
		}
		gotoxy(x,y);
		pintar_cuadrito(x,y);
		Global_a=(x+y);
		mostrar_globales();
	
}
void Paleta_colores(bool v){ //Esto solo muestra los colores posibles de fuente a elegir
	
	x=54;y=5;
	
	for(int i=240;i<=254;i++){
		gotoxy (x,y++);
		if (v==true){
			Color(i);
			cout<<"###############";
		}
		else {cout<<"               ";}
	}
	
	if (v==true)Color(240);
	y=8;x=20;
	
}
bool Color_fuente(void){ //Esto es una flecha para elegir el color de funte
	
	
	char tecla = getch(); //Asigna a tecla el caracter
	if (tecla == ENTER) {preferenciasActual.color=235+y;Color(235+y);gotoxy(x,y);cout<<"   ";Paleta_colores(false);x=5;y=5;return true;}
	if (tecla == IZQUIERDA){gotoxy(x,y);cout<<"   ";Paleta_colores(false); x=5;y=5;return true;}
	if ((tecla == ARRIBA)&&(y==5)){gotoxy(50,5);cout<<"   "; y=20;}
	if ((tecla == ABAJO)&&(y==19)){gotoxy(50,19);cout<<"   "; y=4;}
	if ((tecla == ARRIBA)&&(y>=5)){ y--;}
	if ((tecla == ABAJO)&&(y<=19)){ y++;}
	gotoxy(x,y-1);cout<<"   ";
	gotoxy(x,y);cout<<"-->";
	gotoxy(x,y+1);cout<<"   ";
	return false;	
}

bool mover_flechita(void){//borra el cuadro, cambia x e y, imprime el cuadro
	
	bool v=false;
	char tecla = getch(); //Asigna a tecla el caracter
	gotoxy(x,y);
	cout<<"   ";
	switch(Global_guia){
	case 1:{
		switch (x){	
			case 5:{		
				if ((tecla == ENTER)&&(y==11)) {return true;}
				if ((tecla == ENTER)&&(y==8)){ }
				if ((tecla == DERECHA)&&(y==5)){ Paleta_colores(true); x=50;y=5;gotoxy(x,y);cout<<"-->";do{v = Color_fuente();}while(v==false);}
				if ((tecla == DERECHA) && (y==8)){ Seleccionar_fondo(); }
				if ((tecla == ABAJO)&&(y==8)){ y=11;}
				if ((tecla == ABAJO)&&(y==5)){ y=8;}
				if ((tecla == ARRIBA)&&(y==8)){ y=5;}
				if ((tecla == ARRIBA)&&(y==11)){ y=8;}
				break;
			}
		}
		break;
	}
	case 2:{
		if (tecla == ENTER){ Global_b=true;}
		if (tecla == ARRIBA){
			switch (y){
			case 21:{x=22; y=19;Global_b=false;break;}
			case 23:{x=22; y=21;Global_b=false;break;}
			case 25:{x=22; y=23;Global_b=false;break;}
			case 27:{x=22; y=25;Global_b=false;break;}
			}
		}
		if (tecla == ABAJO){
			switch(y){
			case 25:{x=22; y=27;Global_b=false;break;}
			case 23:{x=22; y=25;Global_b=false;break;}			
			case 21:{x=22; y=23;Global_b=false;break;}
			case 19:{x=22; y=21;Global_b=false;break;}
			}
		}			
	}
	}
	
	
	
	gotoxy(x,y);cout<<"-->";
	Global_a=(x+y);
	return false;
}
void Seleccionar_fondo(){
	gotoxy(22,9); cout<<"Presiona:     [B] para un fondo blanco";
	gotoxy(22,11);cout<<"              [N] para un fondo negro";
	if (preferenciasActual.fondo == false){
		gotoxy(32,9);cout<<"-->";
	}else{
		gotoxy(32,11);cout<<"-->";
	}
	//MostrarCursor(true);
	char tecla = getch();
	do{
		if ((tecla == 'b')||(tecla == 'B')){
			preferenciasActual.fondo = false;
			gotoxy(32,9);cout<<"-->";
			gotoxy(32,11);cout<<"   ";
		}
		if ((tecla == 'n')||(tecla == 'N')){
			preferenciasActual.fondo = true;
			gotoxy(32,9);cout<<"   ";
			gotoxy(32,11);cout<<"-->";
		}
		tecla = getch();
	} while(tecla != IZQUIERDA);
	gotoxy(x,y);cout<<"-->";
	gotoxy(22,9); cout<<"                                      ";
	gotoxy(22,11);cout<<"                                      ";
}
bool menu_opciones(void){
	transicion(false);
	bool v=false;
	x=5;y=8;
	gotoxy(8,5);cout<<"FUENTE";
	gotoxy(8,8);cout<<"FONDO";
	gotoxy(8,11);cout<<"SALIR";	
	gotoxy(8,36);cout<<"(*) Para desplegar el menu de FUENTE pulse DERECHA";
	gotoxy(8,37);cout<<"(**) En caso de querer fondo negro y fuente blanca: ";
	gotoxy(8,38);cout<<"Seleccione el la fuente de un color y alterne el color de fondo.";
	x=5;y=5;
	gotoxy(x,y); cout<<"-->";
	do{
		v=mover_flechita();
	}while (v==false);
	guardar_preferencias(preferenciasActual);
	return true;
}
void menu_mensajes(void){
	transicion(false);
	gotoxy(4,1);cout<<"Bienvenido: "<<usuarioActual.nombre<<" ...";
	gotoxy(10,28);cout<<"JUGAR!";
	gotoxy(37,28);cout<<"STATS :D";
	gotoxy(10,30);cout<<"CERRAR SESION";
	gotoxy(37,30);cout<<"OPCIONES";
	gotoxy(10,32);cout<<"MI CUENTA";
	gotoxy(37,32);cout<<"INICIADAS";
	gotoxy(10,34);cout<<"PENDIENTES";
	gotoxy(37,34);cout<<"TERMINADAS";
	
	
	pintar_cuadrito(9,27);
	Global_a=25;
}
string captcha (int r, string p, string n){
	int num;
	int a = 1;
	int ordenado [T];
	char unido[T];
	int i = 0, l = 0, m, o = 0, q = 0;
	int aux;
	char captcha[T];
	num = r + (int)n[0] + (int)n[n.size()-1];
	while (num/a > 0){
		ordenado [i] = (num/a)%10;
		i++;
		a=a*10;
	}
	for (int j=0; j<i; j++){
		for (int k=j+1; k<i; k++){
			if(ordenado[j] < ordenado [k]){
				aux = ordenado[j];
				ordenado[j] = ordenado[k];
				ordenado[k] = aux;
			}
		}
	}
	while (l<i+10){
		m=0;
		while (m<2 && q<10){
			unido[l]= p[q];
			m++;
			q++;
			l++;
		}
		unido[l] = (char)ordenado[o]+48;
		l++;
		o++;
	}
	for(int k=0; k<i+10; k++){
		captcha[k] = unido[i+9-k];
	}
	string captchafinal = "";
	for(int k=0; k<i+10; k++){
		captchafinal += captcha[k];
	}
	return captchafinal;
	}

bool generar_capcha(bool& banderita,int& Centinela) {
		transicion(false);
		
		Global_captcha="";
		string comprobar;
		int r;
		string p = "AlGoRiTmOs";
		
		r=((rand()%40001)+10000);
		
		Global_captcha = captcha(r, p, usuarioActual.nombre);
		gotoxy(5,4);cout<<"Has realizado muchos intentos fallidos!!";
		gotoxy(5,5);cout<<"Ingresa el siguiente capcha para corroborar que seas humano :)";
		Color(252);
		gotoxy(5,36);cout<<"(*)Recuerda diferenciar un Cero 0 de una vocal O mayuscula";
		gotoxy(5,8); cout<<Global_captcha;
		Color(240);
		gotoxy(5,10); cin>>ws; cin>>comprobar;	
		if (Global_captcha == comprobar) {
			banderita=true;
			Centinela=3;
			return true;
		}else{
			SALIDA=true;
			registrado=true;
			Seguridad_menu();
			return false;
		}
	}
int ruleta(int x1, int y1){
	//cargaDePreguntas(matrizPreguntas);
	gotoxy(x1+4,y1);
	cout<< "Fisica I";
	gotoxy(x1+4,y1+1);
	cout<< "Matematica Discreta";
	gotoxy(x1+4,y1+2);
	cout<< "Algoritmos y Estrucutras de Datos";
	gotoxy(x1+4,y1+3);
	cout<< "Arquitectura de Computadoras";
	gotoxy(x1+4,y1+4);
	cout<< "Analisis Matematico I";
	
	for (int j=0;j<2;j++){
		for (int i=0;i<5;i++){
			gotoxy(70,5); if (i%2==0){printf("%c",4);}else{printf("%c",254);};
			gotoxy(x1,y1+i);
			cout<<"-->";
			Sleep(100);
			gotoxy(x1,y1+i);
			cout<<"   ";
		}
	}
	
	for (int i=0;i<5;i++){
		gotoxy(70,5); if (i%2==0){printf("%c",4);}else{printf("%c",254);}
		gotoxy(x1,y1+i);
		cout<<"-->";
		Sleep(200);
		gotoxy(x1,y1+i);
		cout<<"   ";
	}
	
	int a=1;
	/*
	for (int i=0;i<5;i++){
	gotoxy(x,y+i);
	cout<<"-->";
	Sleep(300+300*i);
	gotoxy(x,y+i);
	
	a = rand()%2;
	if (a == 0){
	gotoxy(x,y+5);
	return i;
	}
	if (i == 4){
	gotoxy(x,y+5);
	return 4;
	}
	cout<<"   ";
	}
	*/
	
	while (a != 0){
		for (int i=0;i<5;i++){
			gotoxy(70,5); 
			if (i%2==0){printf("%c",4);}
			else{printf("%c",254);}
			gotoxy(x1,y1+i);
			cout<<"-->";
			Sleep(300);
			a = rand()%4;
			if (a == 0){
				A[Global_contador]=i;
				gotoxy(15,8); Color(249); system("PAUSE"); Color(240);
				gotoxy(15,8);cout<<"                                       ";
				gotoxy(x1,y1+i);
				cout<<"   ";
				return i;
			}
			gotoxy(x1,y1+i);
			cout<<"   ";
		}
	}
	
	return 0;
}

int pregunta(int a){
	int b;
	if (a==5){
		Seleccion_categoria(a);
	}
	switch (a){
	case 0:
		b = rand()%tamanoCategorias[a];
		break;
	case 1:
		b = rand()%tamanoCategorias[a];
		break;
	case 2:
		b = rand()%tamanoCategorias[a];
		break;
	case 3:
		b = rand()%tamanoCategorias[a];
		break;
	case 4:
		b = rand()%tamanoCategorias[a];
		break;
	}
	
	for(int i=0;i<10;i++){
		if(B[i] == b && A[i] == a){
			b = pregunta(a);
		}
	}
	
	B[Global_contador]=b;
	return b;
	
}
void Seleccion_categoria(int& a){
	/*transicion(false);
	gotoxy(5,5);cout<<"Selecciona la categoria de pregunta!";
	gotoxy(5,5);cout<<"";
	gotoxy(5,5);cout<<"";
	gotoxy(5,5);cout<<"";
	gotoxy(5,5);cout<<"";
	*/
	
}
void validar_salida(void){
	transicion(false);
	Global_guia=2;
	x=20;y=19;
	Global_b=false;
	Global_a=39;
	gotoxy(20,14); cout<<"Estas seguro de que quieres ";
	Color(252); cout<<"SALIR"; Color(240);
	cout<<"?";
	gotoxy(21,20); cout<<"NONONO!";
	gotoxy(41,20); cout<<"Sip.";
	pintar_cuadrito(x,y);
	while(Global_b==false){
		gotoxy(1,1);cout<<Global_a;
		mover_cuadrito();
	}
	if( Global_a == 39 ) {
		SALIDA = false;
	}
	if(Global_a == 59){
		SALIDA = true;
		registrado=true;
	}
}
void mostrar_globales(void){
	if(debug==true){
	gotoxy(5,39);
	cout<<"     Y="<<y<<" X="<<x<<" Global_a="<<Global_a<<" Global_guia="<<Global_guia<<" Global_b="<<Global_b<<"IDs: "<<ids<<"     ";
	}
}
void obtenerFechaActual(fecha & f) {
	struct tm *tiempo;
	
	
	time_t fecha_sistema;
	time(&fecha_sistema);
	tiempo=localtime(&fecha_sistema);
	
	f.anio=tiempo->tm_year + 1900;
	f.mes=tiempo->tm_mon + 1;
	f.dia=tiempo->tm_mday;
	f.hora=tiempo->tm_hour;
	f.mins=tiempo->tm_min;
	f.segs=tiempo->tm_sec;
}
bool obtenerIdUsuario(int & id) {
	ifstream archivo;
	usuario usr;
	int i=0;
	bool fin=false, rta=true;
	
	archivo.open(archUsuarios, ios::in);
	
	if(archivo.fail())
		rta=false;
	else {
		while(!fin){
			archivo >> usr.id >> usr.nombre >> usr.clave;
			if(archivo.eof())
				fin=true;
			i++;
		}
		id=++i;
		archivo.close();
	}
	return rta;
}
bool buscarXIdUsuario(int id, usuario & usr){
	ifstream archivo;
	
	bool fin=false, encontrado=false;
	
	archivo.open(archUsuarios, ios::in);
	
	if(!archivo.fail()){
		while(!fin && !encontrado){
			archivo >> usr.id >> usr.nombre >> usr.clave;
			
			if(usr.id==id) {
				encontrado=true;
			}
			
			if(archivo.eof())
				fin=true;
		}
		archivo.close();
	}
	return encontrado;
}
bool buscarXNombreUsuario(string nombre, usuario & usr){
	ifstream archivo;
	
	bool fin=false, encontrado=false;
	
	archivo.open(archUsuarios, ios::in);
	
	if(!archivo.fail()){
		while(!fin && !encontrado){
			archivo >> usr.id >> usr.nombre >> usr.clave;
			
			if(usr.nombre==nombre) {
				encontrado=true;
			}
			
			if(archivo.eof()) 
				fin=true;
		}
		archivo.close();
	}
	return encontrado;
}
void cargaDePreguntas(Pregunta matrizPreguntas[][MAX_COL]){
	ifstream  baseDePreguntas;
	int numeroAtributo = 0, idCategoria, idPregunta, numeroGrupo, opcionCorrecta;
	char pregunta[1000], opcion1[1000], opcion2[1000], opcion3[1000], opcion4[1000],entrada[1000];
	baseDePreguntas.open("basepreguntas-nueva.txt");
	if(!baseDePreguntas){
		//Error al abrir el archivo
		cout << "El archivo no puedo ser abierto. Se cerrara el programa." << endl;
		system("pause");
		exit(-1);
	}
	baseDePreguntas.unsetf(ios::skipws);
	while(!baseDePreguntas.eof()){
		if(numeroAtributo == 8 )
			baseDePreguntas.getline(entrada,1000,'\n'); //Consume el \n que hay entre las preguntas, ya que no estan separadas por un arroba
		else{
			baseDePreguntas.getline(entrada,1000,'@');
		}
		switch(numeroAtributo){
		case 0:
			idPregunta = atoi(entrada)-1;
			break;
		case 1:
			idCategoria = atoi(entrada) ;
			break;
		case 2:
			numeroGrupo = atoi(entrada);
			break;
		case 3:
			strcpy(pregunta,entrada);
			break;
		case 4:
			strcpy(opcion1,entrada);
			break;
		case 5:
			strcpy(opcion2,entrada);
			break;
		case 6:
			strcpy(opcion3,entrada);
			break;
		case 7:
			strcpy(opcion4,entrada);
			break;
		case 8:
			opcionCorrecta=atoi(entrada);
			break;
		}
		numeroAtributo++;
		if(numeroAtributo == 9){
			numeroAtributo = 0;
			matrizPreguntas[idCategoria][idPregunta].idCategoria = idCategoria;
			matrizPreguntas[idCategoria][idPregunta].idPregunta = idPregunta;
			matrizPreguntas[idCategoria][idPregunta].numeroGrupo = numeroGrupo;
			matrizPreguntas[idCategoria][idPregunta].pregunta = pregunta;
			matrizPreguntas[idCategoria][idPregunta].opciones[0] = opcion1;
			matrizPreguntas[idCategoria][idPregunta].opciones[1] = opcion2;
			matrizPreguntas[idCategoria][idPregunta].opciones[2] = opcion3;
			matrizPreguntas[idCategoria][idPregunta].opciones[3] = opcion4;
			matrizPreguntas[idCategoria][idPregunta].opcionCorrecta = opcionCorrecta;
		}
	}
}
int imprimir_opcion(string opcion, int i, int cont){
	if(opcion.size() < 50){
		gotoxy(7,10+cont);
		Color(241);
		cout << (i+1) << ") ";
		Color(240);
		cout<< opcion;
		cont++;
	}else{
		int j=0;
		gotoxy(7,10+cont);
		cont++;
		Color(241);
		cout << (i+1) << ") ";
		Color(240);
		for(int k = 0; k<opcion.size(); k++){
			if (j>50 && opcion[k]==' '){
				gotoxy(7,10+cont);
				cont++;
				j=0;
			}else{
				cout << opcion[k];
				j++;
			}
		}
	}
	return cont;
}
void Jugar_partida(partida& pendiente, jugada& nueva,int& aux, bool nuevo){ //Se modifican una partida y una jugada. Dependiendo el bool se adapta a una pendiente o una nueva. No guarda nada 
	int z=0;
	gotoxy(7,3);cout<<"Pregunta Nro: "<<Global_contador+1<<"                                             ";
	Color(240);
	if (Global_contador<0){
		gotoxy(15,8);
		system("PAUSE");
		gotoxy(15,8);
		cout<<"                                       ";
	}
	for(int i=0; i<20; i++){
		gotoxy(0,10+i);
		printf("UTN                                                                         UTN ");
	}
	for(int i=0; i<4; i++){
		gotoxy(0,6+i);
		printf("UTN                                                                         UTN ");
	}
	cargaDePreguntas(matrizPreguntas);
	if (nuevo==true){
		z = ruleta_provisional();
		A[Global_contador]=z;
		transicion(false);
		grilla(4,30,false);
		int j=Global_contador,v=0;//v es un int que solo se usa para completar el parametro de marcarGrilla
		Global_contador=0;
		for(int i=0;i<j;i++){
			marcarGrilla(nueva.rtas[i],v);
			Global_contador++;
		}
		Global_contador=j;
		aux = pregunta(z);
	}else{
		z = pendiente.categorias[Global_contador];
		aux = pendiente.preguntas[Global_contador];
	}
	Color(241);
	switch (z){ //Imprime sobre la pregunta, la categoria correspondiente
	case 0:{gotoxy(35,3);cout<<"["<<categorias[z]<<"]";break;	}
	case 1:{gotoxy(30,3);cout<<"["<<categorias[z]<<"]";break;}
	case 2:{gotoxy(23,3);cout<<"["<<categorias[z]<<"]";break;}
	case 3:{gotoxy(24,3);cout<<"["<<categorias[z]<<"]";break;}
	case 4:{gotoxy(29,3);cout<<"["<<categorias[z]<<"]";break;}
	}
	Color(240);
	for(int i=0; i<5; i++){
		gotoxy(4,10+i);
		printf("                                             ");
	}
	gotoxy(7,6);
	int cont = 1;
	bool pasado = false;
	//Hay segmentation fault
	if(matrizPreguntas[z][aux].pregunta.size() < 60){ 
		gotoxy(7,6);
		cout << matrizPreguntas[z][aux].pregunta;
	}else{
		for(int i = 0; i<matrizPreguntas[z][aux].pregunta.size(); i++){
			if (i%60==0 && i!=0){
				cout << matrizPreguntas[z][aux].pregunta[i];
				pasado = true;
			}else if(pasado == true && matrizPreguntas[z][aux].pregunta[i] == ' ' ){
				gotoxy(7,6+cont);
				cont++;
				pasado = false;
			}else{
				cout << matrizPreguntas[z][aux].pregunta[i];
			}
		}
	}
	bool arr [4];
	for(int i=0; i<4; i++){
		arr[i]=true;
	}
	int a, correcta;
	cont =0;
	for(int i=0; i<4; i++){
		a =(rand()%4);
		while (arr[a]==false){
			a =(rand()%4);
		}
		cont = imprimir_opcion(matrizPreguntas[z][aux].opciones[a], i, cont);
		if (a+1==matrizPreguntas[z][aux].opcionCorrecta){
			correcta = i+1;
		}
		arr [a] = false;
	}
	clock_t start; //Comienza el tiempo de un reloj
	double duracion, duracion2=30; 
	bool SinSeleccion=true, TimeOut=false; //Booleanos para controlar el ciclo del tiempo
	start = clock();
	gotoxy (7,28);cout<<"Tiempo: 30.000 "<<(char)34; //Decoracion
	mostrar_creditos(30,22);
	gotoxy(22,26);Color(241);cout<<"[5]";Color(240);cout<<" -> Mas tiempo $3";Color(241);cout<<" [6]";Color(240);cout<<" -> Ayuda! $5";
	while( SinSeleccion && !TimeOut){ //Mientras no se oprima nada y haya tiempo
		if (kbhit()) { //kbhit detecta la pulsacion de una tecla y reponde con verdadero o falso
			char tecla=getch(); //Se obtiene la tecla
			if (tecla>48 && tecla<55){ //Si la tecla ingresada se encuentra entre [1 y 6]
				int teclaconvertida = (tecla - 48); //Restamos para obtener el numero desde la tabla ascii
				gotoxy(10,20);
				if (teclaconvertida==5 || teclaconvertida == 6){
					switch(teclaconvertida){
					case 5:{
						if (actualizar_creditos(3,false,preferenciasActual.id)){
							if ((duracion2-duracion)<60){ //Hacemos esta corroboracion para que no se produzcan errores visuales por comprar mucho tiempo
								duracion2+=10; 
								duracion-=10;	
							}else{
								gotoxy(24,28);
								cout<<"YA TIENES MUCHO TIEMPO!          ";
							}
						}else{
							gotoxy(24,28);
							cout<<"NO TIENES MAS CREDITOS!          ";
						}
						break;
					}
					case 6:{
							ayudita(correcta);
							break;
						}
					}
					mostrar_creditos(30,22);
				}else{
					if (teclaconvertida == correcta){//Comprobamos que la opcion elegida sea igual a la opcion correcta de la pregunta seleccionada
						cout<<"Respuesta Correcta!!";
						nueva.rtas[Global_contador]= true;
						marcarGrilla(true, nueva.puntaje);
					}else{
						cout<<"Respuesta Incorrecta!! La opcion correcta es la: "<<correcta;
						nueva.rtas[Global_contador]= false;
						marcarGrilla(false, nueva.puntaje);
					}
					SinSeleccion=false;
				}
			}			
		}
		Sleep(30); //Para no actualizar tan rapido la actualizacion del tiempo restante
		duracion = ( clock() - start ) / (double) CLOCKS_PER_SEC; //Se actualiza el tiempo transcurrido
		gotoxy(15,28);cout<< duracion2-duracion <<" "<<endl; //Se muestra el tiempo restante
		if ( duracion >= 30 || duracion2 <=0 ){
			TimeOut = true;
			marcarGrilla(false, nueva.puntaje);			
			gotoxy (7,28);cout<<"Tiempo: 0.000  ";
			gotoxy (10,25);cout<<"Tiempo fuera!! La opcion correcta es la: "<<correcta;
		}
	}
	Sleep(3000);
	gotoxy(7,28);cout<<"                   ";
	gotoxy(10,20); cout<<"                                                    ";
	gotoxy (4,15);cout<<"                         ";
}
void grilla(int x1, int y1,bool a){ //Marcara la tabla donde se llevara VISUALMENTE el resultado de las respuestas
	//x1=4 y1=30 coordenadas predeterminadas
	//71 x (5 o 7)
	gotoxy(x1,y1);
	printf("%c%c%c%c%c%c%c%c%c%c%c%c%c%c%c%c%c%c%c%c%c%c%c%c%c%c%c%c%c%c%c%c%c%c%c%c%c%c%c%c%c%c%c%c%c%c%c%c%c%c%c%c%c%c%c%c%c%c%c%c%c%c%c%c%c%c%c%c%c%c%c\n",201,205,205,205,205,205,205,203,205,205,205,205,205,205,203,205,205,205,205,205,205,203,205,205,205,205,205,205,203,205,205,205,205,205,205,203,205,205,205,205,205,205,203,205,205,205,205,205,205,203,205,205,205,205,205,205,203,205,205,205,205,205,205,203,205,205,205,205,205,205,187);
	gotoxy(x1,y1+1);
	printf("%c   1  %c   2  %c   3  %c   4  %c   5  %c   6  %c   7  %c   8  %c   9  %c  10  %c\n",186,186,186,186,186,186,186,186,186,186,186);
	gotoxy(x1,y1+2);
	printf("%c%c%c%c%c%c%c%c%c%c%c%c%c%c%c%c%c%c%c%c%c%c%c%c%c%c%c%c%c%c%c%c%c%c%c%c%c%c%c%c%c%c%c%c%c%c%c%c%c%c%c%c%c%c%c%c%c%c%c%c%c%c%c%c%c%c%c%c%c%c%c\n",204,205,205,205,205,205,205,206,205,205,205,205,205,205,206,205,205,205,205,205,205,206,205,205,205,205,205,205,206,205,205,205,205,205,205,206,205,205,205,205,205,205,206,205,205,205,205,205,205,206,205,205,205,205,205,205,206,205,205,205,205,205,205,206,205,205,205,205,205,205,185);
	gotoxy(x1,y1+3);
	printf("%c      %c      %c      %c      %c      %c      %c      %c      %c      %c      %c\n",186,186,186,186,186,186,186,186,186,186,186);
	if (a){
		gotoxy(x1,y1+4);
		printf("%c%c%c%c%c%c%c%c%c%c%c%c%c%c%c%c%c%c%c%c%c%c%c%c%c%c%c%c%c%c%c%c%c%c%c%c%c%c%c%c%c%c%c%c%c%c%c%c%c%c%c%c%c%c%c%c%c%c%c%c%c%c%c%c%c%c%c%c%c%c%c\n",204,205,205,205,205,205,205,206,205,205,205,205,205,205,206,205,205,205,205,205,205,206,205,205,205,205,205,205,206,205,205,205,205,205,205,206,205,205,205,205,205,205,206,205,205,205,205,205,205,206,205,205,205,205,205,205,206,205,205,205,205,205,205,206,205,205,205,205,205,205,185);
		gotoxy(x1,y1+5);
		printf("%c      %c      %c      %c      %c      %c      %c      %c      %c      %c      %c\n",186,186,186,186,186,186,186,186,186,186,186);
		y1+=2;
	}
	gotoxy(x1,y1+4);
	printf("%c%c%c%c%c%c%c%c%c%c%c%c%c%c%c%c%c%c%c%c%c%c%c%c%c%c%c%c%c%c%c%c%c%c%c%c%c%c%c%c%c%c%c%c%c%c%c%c%c%c%c%c%c%c%c%c%c%c%c%c%c%c%c%c%c%c%c%c%c%c%c\n",200,205,205,205,205,205,205,202,205,205,205,205,205,205,202,205,205,205,205,205,205,202,205,205,205,205,205,205,202,205,205,205,205,205,205,202,205,205,205,205,205,205,202,205,205,205,205,205,205,202,205,205,205,205,205,205,202,205,205,205,205,205,205,202,205,205,205,205,205,205,188);
}
void marcarGrilla(bool a, int& puntaje){
	switch(Global_contador+1){
	case 10:{
		gotoxy(71,33);
		break;
	}
	case 1:{
		gotoxy(8,33);
		break;
	}
	case 2:{
		gotoxy(15,33);
		break;
	}
	case 3:{
		gotoxy(22,33);
		break;
	}
	case 4:{
		gotoxy(29,33);
		break;
	}
	case 5:{
		gotoxy(36,33);
		break;
	}
	case 6:{
		gotoxy(43,33);
		break;
	}
	case 7:{
		gotoxy(50,33);
		break;
	}
	case 8:{
		gotoxy(57,33);
		break;
	}
	case 9:{
		gotoxy(64,33);
		break;
	}
	}
	if (a == true){
		Color(250);
		cout<<(char)251;
		puntaje+=3;
	}else{
		Color(252);
		cout<<"x";
	}
	Color(240);
}
void guardar_partidas(partida& pendiente){
	ifstream a;
	partida aux;
	a.open(archPartida, ios::binary);
	bool haypartida = false;
	int contador = 0;
	if (a.fail()){
		ofstream f;//Declaramos el archivo de salida y lo abrimos como archivo binario
		f.open(archPartida, ios::binary | ios::out);
		f.write((char*)&pendiente,sizeof(partida));
		f.close();
	}else{
		
		a.read((char*)&aux,sizeof(partida));
		while((!a.eof()) && (haypartida==false)){
			if (aux.idPartida == pendiente.idPartida){
				haypartida = true;
			}else{
				contador++;
				a.read((char*)&aux,sizeof(partida));
			}
		}
		a.close();
		
		ofstream f;
		f.open(archPartida, ios::binary | ios::in | ios::out );
		f.seekp(sizeof(partida)*contador);
		f.write((char*)&pendiente,sizeof(partida));
		f.close();
	}
	
}
bool leer_iniciadas(void){ //Se leera "Partidas.dat" y se mostraran en pantalla
	ifstream f;//Declaramos el archivo de solo lectura y lo abrimos como archivo binario
	f.open(archPartida, ios::binary );
	partida aux;
	bool haypartida = false;
	int contador=0, contador2=1;
	Nodo2 * lista = NULL, *aux01 ,*nuevo, *anti;
	
	if (f.fail()){
		gotoxy(7,5);cout<<"Error al abrir Partidas.dat";
		gotoxy(7,7);system("PAUSE");
	}else{
		f.read((char*)&aux,sizeof(partida));
		while(!f.eof()){
			if (aux.idUI == usuarioActual.id){
				if (aux.estado==0){
					if (!haypartida){ //Agrega el primer elemento al principio
						haypartida= true;
						aux01 = lista;
						lista = new Nodo2;
						lista->id = contador2;
						lista->ant = NULL;
						lista->info = aux;
						lista->sig = aux01;
					}else{ //Agrega un elemento al final de la lista
						aux01=lista;
						for (aux01 = lista; aux01->sig != NULL; aux01 = aux01->sig){
							if ((aux01->sig)->sig==NULL){
								anti = aux01;
							}
						}
						//Seteamos el nuevo nodo de la lista
						nuevo = new Nodo2;
						nuevo->info = aux;
						nuevo->id = contador2;
						nuevo->ant = anti;
						nuevo->sig = NULL;
						aux01->sig = nuevo;
					}
					contador2++;
				}
				//La siguiente variable contara la cantidad de partidas encontradas
				contador++; 
			}
			f.read((char*)&aux,sizeof(partida));
		}
		f.close();
		if(!haypartida){
			gotoxy(25,5);cout <<"No tienes partidas partidas pendientes" ;
			gotoxy(25,7);system("PAUSE");
		}
		else{
			contador=1;
			for (aux01 = lista; aux01->sig != NULL; aux01 = aux01->sig) {
				contador++;
			}
			contador = seleccion_partidas(7,2,lista,contador,false);
		}
	}
	return false;
}
bool leer_terminadas(void){
	ifstream f;//Declaramos el archivo de solo lectura y lo abrimos como archivo binario
	f.open(archPartida, ios::binary );
	partida aux;
	bool haypartida = false;
	int contador=0, contador2=1;
	Nodo2 * lista = NULL, *aux01 ,*nuevo, *anti;
	
	if (f.fail()){
		gotoxy(7,5);cout<<"Error al abrir Partidas.dat";
		gotoxy(7,7);system("PAUSE");
	}else{
		f.read((char*)&aux,sizeof(partida));
		while(!f.eof()){
			if ((aux.idUI == usuarioActual.id)||(aux.idUO == usuarioActual.id)){
				if (aux.estado>0){
					if (!haypartida){ //Agrega el primer elemento al principio
						haypartida= true;
						aux01 = lista;
						lista = new Nodo2;
						lista->id = contador2;
						lista->ant = NULL;
						lista->info = aux;
						lista->sig = aux01;
					}else{ //Agrega un elemento al final de la lista
						aux01=lista;
						for (aux01 = lista; aux01->sig != NULL; aux01 = aux01->sig){
							if ((aux01->sig)->sig==NULL){
								anti = aux01;
							}
						}
						//Seteamos el nuevo nodo de la lista
						nuevo = new Nodo2;
						nuevo->info = aux;
						nuevo->id = contador2;
						nuevo->ant = anti;
						nuevo->sig = NULL;
						aux01->sig = nuevo;
					}
					contador2++;
				}
				//La siguiente variable contara la cantidad de partidas encontradas
				contador++; 
			}
			f.read((char*)&aux,sizeof(partida));
		}
		f.close();
		if(!haypartida){
			gotoxy(25,5);cout <<"No tienes partidas partidas terminadas" ;
			gotoxy(25,7);system("PAUSE");
		}
		else{
			contador=1;
			for (aux01 = lista; aux01->sig != NULL; aux01 = aux01->sig) {
				contador++;
			}
			contador = seleccion_partidas(7,2,lista,contador,false);
		}
	}
	return false;
}
void guardar_jugadas(jugada& pendiente){
	ofstream archi ;
	archi.open(archJugada, ios::binary | ios::out | ios::app); //abrimos el binario y nos ponemo al final
	archi.write((char *) &pendiente, sizeof(jugada)); //guardamo pendiente al final
	archi.close();
}
void leer_jugadas(jugada& r, partida& actual, bool abre){ //Tomara la partida ya jugada a partir de la id de la jugada pendiente ya seleccionada
	//abre significa si pregunta por el que abrio la partida o por el otro
	ifstream f;
	f.open(archJugada, ios::binary );
	int contador=0;
	int aux;
	if(abre){
		aux = actual.idUI;
	}else{
		aux = actual.idUO;
	}
	bool salga = false;
	while(!f.eof()&& !salga){
		f.seekg(sizeof(jugada)*contador);
		f.read((char *) &r, sizeof(jugada));
		if ((actual.idPartida == r.idPartida)&&(aux==r.idUsr)){
			salga=true;
		}
		contador++;
	}
}
void marcarGrillaOponente(bool rtas[]){
	gotoxy (7,28);cout<<"               ";
	int j=8;
	gotoxy(j,35);
	for(int i=0;i<10;i++){
		if (rtas[i] == true){
			Color(250);
			printf("%c",251);
		}else{
			Color(252);
			printf("x");
		}
		j+=7;
		gotoxy(j,35);
	}
}
int controlar_iniciadas(int id,bool asd){ //Se leera "Partidas.dat" y se mostraran en pantalla
	ifstream f;//Declaramos el archivo de solo lectura y lo abrimos como archivo binario
	f.open(archPartida, ios::binary | ios::in );
	partida aux;
	bool haypartida = false;
	int contador=0, contador2=0, b=9;
	if (f.fail()){
		gotoxy(7,5);cout<<"Error al abrir Partidas.dat";
		return 0;
	}else{
		while(!f.eof()){
			f.read((char*)&aux,sizeof(partida));
			if (asd==true){
				if (aux.idUI == id){
					if (aux.estado==0){
						haypartida= true;
						contador2++;
					}
					contador++;
				}
			}else{
				if (aux.idUO == id){
					if (aux.estado==0){
						haypartida= true;
						contador2++;
					}
					contador++;
				}
			}
		}
		if (contador2>=25){
			if (asd){
				gotoxy(5,8);cout<<"Usted ha alcanzado el limite de partidas iniciadas";
				gotoxy(5,10);cout<<"Por favor espere a que un oponente finalice su partida";
				transicion(false);
			}
			f.close();
			return 1;
		}else{
			f.close();
			return 2;
		}
	}
	
}
void Seguridad_menu(){
	Color(252);
	transicion(true);
	Color(240);
	gotoxy(9,5);cout<<"Por motivos de seguridad has sido echado de la aplicacion";
	gotoxy(9,7);cout<<"#########################################################";
	gotoxy(9,8);cout<<"##   ################### ## ############### ## ###    ###";
	gotoxy(9,9);cout<<"## ## ### ### ##   ##### ## ###  ###    ### ## ### ######";
	gotoxy(9,10);cout<<"##   #####   ### #######    ## ## ## ######   ####    ###";
	gotoxy(9,11);cout<<"## ## ##### ####  ###### ## ##    ## ###### ### ##### ###";
	gotoxy(9,12);cout<<"##   ###### ####   ##### ## ## ## ##    ### ### ##    ###";
	gotoxy(9,13);cout<<"#########################################################";
	gotoxy(9,38);system("PAUSE");
}
int contador_jugadores(){
	ifstream f;
	f.open(archUsuarios);
	usuario aux;
	int contador = 0;
	if (f.fail()){
		cout<<"Error al abrir "<<archUsuarios;
		ids=0;
		return 0;
	}else{
		while (!f.eof()){
			f>>aux.id>>aux.nombre>>aux.clave;
			contador++;
		}
		ids=contador;
		return aux.id; //La idea es retornar la cantidad de usuarios registrados
	}
}
int ruleta_provisional(){
	transicion(false);
	int a=((rand()%6)+60); //Aqui se elige la categoria y se le suman 60 para que luego se den 10 vueltas
	if (Global_contador!=0){
		for(int i=0;i<=6;i++){
			dibujar_ruleta_relleno(-11,-7,(i%7));
		}
	}else{
		for(int i=0;i<=6;i++){
			dibujar_ruleta_relleno(-11,-7,(i%7));
			Sleep(300);
		}
	}
	gotoxy(20,37);cout<<"[PRESIONA UNA TECLA PARA GIRAR LA RULETA!]";
	system("PAUSE>NULL"); remove("NULL");
	gotoxy(20,37);cout<<"                                          ";
	for(int i=0;i<=a;i++){
		dibujar_ruleta_marco(-11,-7,(i%6));
		Sleep(2*i);
	}
	Sleep(500);
	transicion(false);
	if (a-60==0){
		return corona_menu();
	}else{
		return (a-61);
	}
}
void corona_dibujo(void){
	string Directorio = ExePath() , archPruebita = "corona.txt" , carpeta = "Dibujos" ;
	Directorio = Directorio + (char)92 + carpeta + (char)92 + archPruebita;
	const char * Directorioconstante = Directorio.data();
	
	gotoxy(0,5);
	ifstream Reader(Directorioconstante);             //Open file
	string Art = getFileContents (Reader);       //Get file
	cout<<Art<<endl;               //Print it to the screen
	Reader.close();                           //Close file
}
int corona_menu(){
	transicion(true);
	corona_dibujo();
	gotoxy(25,11);Color(240);cout<<"[ELIGE UNA CATEGORIA]";
	gotoxy(25,19);Color(254);cout<<categorias[0];
	gotoxy(25,21);Color(253);cout<<categorias[1];
	gotoxy(25,23);Color(252);cout<<categorias[2];
	gotoxy(25,25);Color(250);cout<<categorias[3];
	gotoxy(25,27);Color(249);cout<<categorias[4];
	gotoxy(22,19);Color(240);cout<<"-->";
	Global_b=false;
	Global_guia=2;
	y=19;x=32;
	do{
		mover_flechita();
		if (Global_b==true){
			switch(y){
			case 19:{transicion(false);return 0;}//retorna FisicaI
			case 21:{transicion(false);return 1;}//retorna MAD
			case 23:{transicion(false);return 2;}//retorna AEDD
			case 25:{transicion(false);return 3;}//retorna ADC
			case 27:{transicion(false);return 4;}//retorna AMI
			}
		}
	} while(Global_b==false);
	
	return 0;
}
void dibujar_ruleta_relleno(int x1, int y1,int a){
	/*
	En punto (-11,-5):
	Sobran a cada lado 5 columnas, es decir, que esta centrado y sobran 7 filas arriba y 
	6 abajo asi que no se puede centrar verticalmente.
	SUGERENCIAS/OBSERVAICONES: 
	Subirlo y comprobar que entre la grilla con las preguntas correctas e incorrectas
	*/
	switch(a){
	case 0:{
		Color(240);//Blanco
		gotoxy(x1+40,y1+8) ;cout<<"                       ";
		gotoxy(x1+40,y1+9) ;cout<<" ##################### ";
		gotoxy(x1+40,y1+10);cout<<" ##################### ";
		gotoxy(x1+40,y1+11);cout<<"  ################### ";
		gotoxy(x1+40,y1+12);cout<<"   ################# ";
		gotoxy(x1+40,y1+13);cout<<"    ############### ";
		gotoxy(x1+40,y1+14);cout<<"     ############# ";
		gotoxy(x1+40,y1+15);cout<<"      ########### ";
		gotoxy(x1+40,y1+16);cout<<"       ######### ";
		gotoxy(x1+40,y1+17);cout<<"        ####### ";
		gotoxy(x1+41,y1+18); cout<<"               ";
		break;
	}
	case 1:{
		Color(254);//Amarillo
		gotoxy(x1+62,y1+10); cout<<"           ";
		gotoxy(x1+61,y1+11); cout<<"        ### ";
		gotoxy(x1+60,y1+12);cout<<"        ##### ";
		gotoxy(x1+60,y1+13);cout<<"       ######## ";
		gotoxy(x1+60,y1+14);cout<<"      ########## ";
		gotoxy(x1+60,y1+15);cout<<"     ############ ";
		gotoxy(x1+60,y1+16);cout<<"    ############## ";
		gotoxy(x1+60,y1+17);cout<<"   ################ ";
		gotoxy(x1+60,y1+18);cout<<"  ################## ";
		gotoxy(x1+60,y1+19);cout<<"   ################## ";
		gotoxy(x1+60,y1+20);cout<<"   ################## ";
		gotoxy(x1+60,y1+21);cout<<"     ################ ";
		gotoxy(x1+60,y1+22);cout<<"       ############### ";
		gotoxy(x1+60,y1+23);cout<<"       ############### ";
		gotoxy(x1+60,y1+24);cout<<"        ############### ";
		gotoxy(x1+60,y1+25);cout<<"                        ";
		break;
	}
	case 2:{
		Color(253);//Rosado
		gotoxy(x1+60,y1+25);cout<<"                        ";
		gotoxy(x1+60,y1+26);cout<<"        ############### ";
		gotoxy(x1+60,y1+27);cout<<"       ############### ";
		gotoxy(x1+60,y1+28);cout<<"       ############### ";
		gotoxy(x1+60,y1+29);cout<<"     ################ ";
		gotoxy(x1+60,y1+30);cout<<"   ################## ";
		gotoxy(x1+60,y1+31);cout<<"   ################## ";
		gotoxy(x1+60,y1+32);cout<<"  ################## ";
		gotoxy(x1+60,y1+33);cout<<"   ################ ";
		gotoxy(x1+60,y1+34);cout<<"    ############## ";
		gotoxy(x1+60,y1+35);cout<<"     ############ ";
		gotoxy(x1+60,y1+36);cout<<"      ########## ";
		gotoxy(x1+60,y1+37);cout<<"       ######## ";
		gotoxy(x1+60,y1+38);cout<<"        ##### ";
		gotoxy(x1+61,y1+39); cout<<"        ### ";
		gotoxy(x1+62,y1+40);cout<<"          ";
		break;
	}
	case 3:{
		Color(252);//Rojo
		gotoxy(x1+40,y1+32);cout<<"                ";
		gotoxy(x1+40,y1+33);cout<<"        ####### ";
		gotoxy(x1+40,y1+34);cout<<"       ######### ";
		gotoxy(x1+40,y1+35);cout<<"      ########### ";
		gotoxy(x1+40,y1+36);cout<<"     ############# ";
		gotoxy(x1+40,y1+37);cout<<"    ############### ";
		gotoxy(x1+40,y1+38);cout<<"   ################# ";
		gotoxy(x1+40,y1+39);cout<<"  ################### ";
		gotoxy(x1+40,y1+40);cout<<" ##################### ";
		gotoxy(x1+40,y1+41);cout<<" ##################### ";
		gotoxy(x1+40,y1+42);cout<<"                       ";
		break;
	}
	case 4:{
		Color(250);//verde
		gotoxy(x1+19,y1+25);cout<<"                 ";
		gotoxy(x1+19,y1+26);cout<<" ############### ";
		gotoxy(x1+19,y1+27);cout<<"  ############### ";
		gotoxy(x1+19,y1+28);cout<<"  ############### ";
		gotoxy(x1+19,y1+29);cout<<"  ################ ";
		gotoxy(x1+19,y1+30);cout<<"   ################# ";
		gotoxy(x1+19,y1+31);cout<<"   ################# ";
		gotoxy(x1+19,y1+32);cout<<"    ################## ";
		gotoxy(x1+19,y1+33);cout<<"     ################ ";
		gotoxy(x1+19,y1+34);cout<<"      ############## ";
		gotoxy(x1+19,y1+35);cout<<"       ############ ";
		gotoxy(x1+19,y1+36);cout<<"        ########## ";
		gotoxy(x1+19,y1+37);cout<<"         ######## ";
		gotoxy(x1+19,y1+38);cout<<"           ##### ";
		gotoxy(x1+19,y1+39);cout<<"            ### ";
		gotoxy(x1+19,y1+39);cout<<"                ";
		break;
	}
	case 5:{
		Color(249);//Azul
		gotoxy(x1+19,y1+10);cout<<"                ";
		gotoxy(x1+19,y1+11);cout<<"            ### ";
		gotoxy(x1+19,y1+12);cout<<"           ##### ";
		gotoxy(x1+19,y1+13);cout<<"         ######## ";
		gotoxy(x1+19,y1+14);cout<<"        ########## ";
		gotoxy(x1+19,y1+15);cout<<"       ############ ";
		gotoxy(x1+19,y1+16);cout<<"      ############## ";
		gotoxy(x1+19,y1+17);cout<<"     ################ ";
		gotoxy(x1+19,y1+18);cout<<"    ################## ";
		gotoxy(x1+19,y1+19);cout<<"   ################# ";
		gotoxy(x1+19,y1+20);cout<<"   ################# ";
		gotoxy(x1+19,y1+21);cout<<"  ################ ";
		gotoxy(x1+19,y1+22);cout<<"  ############### ";
		gotoxy(x1+19,y1+23);cout<<"  ############### ";
		gotoxy(x1+19,y1+24);cout<<" ############### ";
		gotoxy(x1+19,y1+25);cout<<"                 ";
		break;
		}
	default:{
		Color(248); //Gris
		gotoxy(x1+43,y1+19);cout<<" ###   ###   ###";
		gotoxy(x1+43,y1+20);cout<<" ###   ###   ###";
		gotoxy(x1+43,y1+21);cout<<"  ###  ###  ###";
		gotoxy(x1+43,y1+22);cout<<"   ###########";
		gotoxy(x1+43,y1+23);cout<<"    #########";
		gotoxy(x1+43,y1+24);cout<<" ###############";
		gotoxy(x1+43,y1+25);cout<<" ###############";
		gotoxy(x1+43,y1+26);cout<<"    #########";
		gotoxy(x1+43,y1+27);cout<<"   ###########";
		gotoxy(x1+43,y1+28);cout<<"  ###  ###  ###";
		gotoxy(x1+43,y1+29);cout<<" ###   ###   ###";
		gotoxy(x1+43,y1+30);cout<<" ###   ###   ###";
		break;} 
	}
}
void dibujar_ruleta_marco(int x1, int y1,int a){
	gotoxy(22,37);cout<<"                                         ";
	switch(a){
	case 0:{
		dibujar_ruleta_relleno(-11,-7,5);
		Color(240);//Blanco
		gotoxy(x1+40,y1+8) ;cout<<" @@@@@@@@@@@@@@@@@@@@@";
		gotoxy(x1+40,y1+9) ;cout<<"@#####################@";
		gotoxy(x1+40,y1+10);cout<<"@#####################@";
		gotoxy(x1+40,y1+11);cout<<" @###################@";
		gotoxy(x1+40,y1+12);cout<<"  @#################@";
		gotoxy(x1+40,y1+13);cout<<"   @###############@";
		gotoxy(x1+40,y1+14);cout<<"    @#############@";
		gotoxy(x1+40,y1+15);cout<<"     @###########@";
		gotoxy(x1+40,y1+16);cout<<"      @#########@";
		gotoxy(x1+40,y1+17);cout<<"       @#######@";
		gotoxy(x1+40,y1+17);cout<<"        @@@@@@@";
		gotoxy(25,37);cout<<"[CORONA]";
		break;
	}
	case 1:{
		dibujar_ruleta_relleno(-11,-7,0);
		Color(254);//Amarillo
		gotoxy(x1+62,y1+10);cout<<"       @@@";
		gotoxy(x1+61,y1+11);cout<<"       @###@";
		gotoxy(x1+60,y1+12);cout<<"       @#####@";
		gotoxy(x1+60,y1+13);cout<<"      @########@";
		gotoxy(x1+60,y1+14);cout<<"     @##########@";
		gotoxy(x1+60,y1+15);cout<<"    @############@";
		gotoxy(x1+60,y1+16);cout<<"   @##############@";
		gotoxy(x1+60,y1+17);cout<<"  @################@";
		gotoxy(x1+60,y1+18);cout<<" @##################@";
		gotoxy(x1+60,y1+19);cout<<"  @##################@";
		gotoxy(x1+60,y1+20);cout<<"  @##################@";
		gotoxy(x1+60,y1+21);cout<<"    @################@";
		gotoxy(x1+60,y1+22);cout<<"      @###############@";
		gotoxy(x1+60,y1+23);cout<<"      @###############@";
		gotoxy(x1+60,y1+24);cout<<"       @###############@";
		gotoxy(x1+60,y1+25);cout<<"        @@@@@@@@@@@@@@@ ";
		gotoxy(25,37);cout<<"["<<categorias[0]<<"]";
		break;
	}
	case 2:{
		dibujar_ruleta_relleno(-11,-7,1);
		Color(253);//Rosado
		gotoxy(x1+60,y1+25);cout<<"        @@@@@@@@@@@@@@@";
		gotoxy(x1+60,y1+26);cout<<"       @###############@";
		gotoxy(x1+60,y1+27);cout<<"      @###############@";
		gotoxy(x1+60,y1+28);cout<<"      @###############@";
		gotoxy(x1+60,y1+29);cout<<"    @################@";
		gotoxy(x1+60,y1+30);cout<<"  @##################@";
		gotoxy(x1+60,y1+31);cout<<"  @##################@";
		gotoxy(x1+60,y1+32);cout<<" @##################@";
		gotoxy(x1+60,y1+33);cout<<"  @################@";
		gotoxy(x1+60,y1+34);cout<<"   @##############@";
		gotoxy(x1+60,y1+35);cout<<"    @############@";
		gotoxy(x1+60,y1+36);cout<<"     @##########@";
		gotoxy(x1+60,y1+37);cout<<"      @########@";
		gotoxy(x1+60,y1+38);cout<<"       @#####@";
		gotoxy(x1+61,y1+39);cout<<"       @###@";
		gotoxy(x1+62,y1+40);cout<<"       @@@";
		gotoxy(25,37);cout<<"["<<categorias[1]<<"]";
		break;
	}
	case 3:{
		dibujar_ruleta_relleno(-11,-7,2);
		Color(252);//Rojo
		gotoxy(x1+40,y1+32);cout<<"        @@@@@@@";
		gotoxy(x1+40,y1+33);cout<<"       @#######@";
		gotoxy(x1+40,y1+34);cout<<"      @#########@";
		gotoxy(x1+40,y1+35);cout<<"     @###########@";
		gotoxy(x1+40,y1+36);cout<<"    @#############@";
		gotoxy(x1+40,y1+37);cout<<"   @###############@";
		gotoxy(x1+40,y1+38);cout<<"  @#################@";
		gotoxy(x1+40,y1+39);cout<<" @###################@";
		gotoxy(x1+40,y1+40);cout<<"@#####################@";
		gotoxy(x1+40,y1+41);cout<<"@#####################@";
		gotoxy(x1+40,y1+42);cout<<" @@@@@@@@@@@@@@@@@@@@@";
		gotoxy(25,37);cout<<"["<<categorias[2]<<"]";
		break;
	}
	case 4:{
		dibujar_ruleta_relleno(-11,-7,3);
		Color(250);//verde
		gotoxy(x1+19,y1+25);cout<<" @@@@@@@@@@@@@@@";
		gotoxy(x1+19,y1+26);cout<<"@###############@";
		gotoxy(x1+19,y1+27);cout<<" @###############@";
		gotoxy(x1+19,y1+28);cout<<" @###############@";
		gotoxy(x1+19,y1+29);cout<<" @################@";
		gotoxy(x1+19,y1+30);cout<<"  @#################@";
		gotoxy(x1+19,y1+31);cout<<"  @#################@";
		gotoxy(x1+19,y1+32);cout<<"   @##################@";
		gotoxy(x1+19,y1+33);cout<<"    @################@";
		gotoxy(x1+19,y1+34);cout<<"     @##############@";
		gotoxy(x1+19,y1+35);cout<<"      @############@";
		gotoxy(x1+19,y1+36);cout<<"       @##########@";
		gotoxy(x1+19,y1+37);cout<<"        @########@";
		gotoxy(x1+19,y1+38);cout<<"          @#####@";
		gotoxy(x1+19,y1+39);cout<<"           @###@";
		gotoxy(x1+19,y1+39);cout<<"            @@@";
		gotoxy(25,37);cout<<"["<<categorias[3]<<"]";
		break;
	}
	case 5:{
		dibujar_ruleta_relleno(-11,-7,4);
		Color(249);//Azul
		gotoxy(x1+19,y1+10);cout<<"            @@@";
		gotoxy(x1+19,y1+11);cout<<"           @###@";
		gotoxy(x1+19,y1+12);cout<<"          @#####@";
		gotoxy(x1+19,y1+13);cout<<"        @########@";
		gotoxy(x1+19,y1+14);cout<<"       @##########@";
		gotoxy(x1+19,y1+15);cout<<"      @############@";
		gotoxy(x1+19,y1+16);cout<<"     @##############@";
		gotoxy(x1+19,y1+17);cout<<"    @################@";
		gotoxy(x1+19,y1+18);cout<<"   @##################@";
		gotoxy(x1+19,y1+19);cout<<"  @#################@";
		gotoxy(x1+19,y1+20);cout<<"  @#################@";
		gotoxy(x1+19,y1+21);cout<<" @################@";
		gotoxy(x1+19,y1+22);cout<<" @###############@";
		gotoxy(x1+19,y1+23);cout<<" @###############@";
		gotoxy(x1+19,y1+24);cout<<"@###############@";
		gotoxy(x1+19,y1+25);cout<<" @@@@@@@@@@@@@@@";
		gotoxy(25,37);cout<<"["<<categorias[4]<<"]";
		break;
	}
	}	
}
int seleccion_partidas(int x1,int y1, Nodo2 * lista, int cantpartidas,bool z){
	/*
	Se le pasan coordenadas para poder mover todo el menu de manera mas facil
	Se pasa una lista y un entero con la cantidad de nodos que tiene, esto identifica la cantidad de partidas
	
	
	En todo caso se retornara el entero "seleccion"
	En caso de seleccionar una partida, se devolvera seleccion con la id del nodo correspondiente
	En caso de no tener partidas o seleccionar salir se retornara un 0
	En caso de tener mas de una pagina:
	En caso de seleccionar "Pg.Sig", pg se incrementara en uno y se imprimira la pagina siguiente
	En caso de seleccionar "Pg.Ant", pg se decrementara en uno y se imprimira la pagina anterior
	*/
	int seleccion=1, pg=0, pgs=(cantpartidas/16), cant_filas;
	/*
	Si la cantidad de lugares que ofrece una pagina "x" es mayor que la cantidad
	de partidas que hay, entonces la cantidad de filas sera igual a las filas
	necesitadas. 
	En cambio, la cantidad de filas sera igual a 16 que es el maximo de filas
	que se disponen por pagina
	*/
	if( ((pg+1)*16) > cantpartidas ){
		cant_filas=(cantpartidas-(16*pg));
	}else{
		cant_filas=16;
	}
	imprimir_grilla_de_partidas(x1+1,y1,cant_filas);
	char tecla;
	pintar_cuadrito2(58,3);gotoxy(60,4);cout<<(char)186<<"  Salir";
	if (cantpartidas>16){
		pintar_cuadrito2(58,7);gotoxy(60,8);cout<<(char)186<<"  Pg. Sig";
		pintar_cuadrito2(58,11);gotoxy(60,12);cout<<(char)186<<"  Pg. Ant";
	}
	y1+=3;
	x1+=2;	
	if (cantpartidas==0){
		gotoxy(59,4);
		cout<<(char)175;
		tecla=getch();
		return 0;
	}else{
		if(z==false){
			x1=59;
			y1=4;
			seleccion=0;
		}
		imprimir_pagina_partidas(lista,pg);
		gotoxy(x1,y1);
		cout<<(char)175;
		do{
			tecla=getch();
			gotoxy(x1,y1);cout<<" ";
			
			switch((int)tecla){
			case ABAJO:{ //Bajar
				if((x1==9)&&(z==true)){
					if(seleccion<(cant_filas+(pg*16))){
						y1+=2;
						seleccion++;
					}
				}else if((x1==59)&&(y1<12)&&(pgs>0)){
					y1+=4;
					seleccion--;
				}
				break;
			}
			case ARRIBA:{ //Subir
				if ((seleccion!=(1+(pg*16)))&&(x1==9)&&(z==true)){
					if (seleccion>1){
						y1-=2;
						seleccion--;
					}else if(seleccion==0){
						y1-=2;
						seleccion=cant_filas;
					}
				}else if((x1==59)&&(y1>4)&&(pgs>0)){
					y1-=4;
					seleccion++;
				}
				break;
			}
			case DERECHA:{//Cambio de columna
				if ((x1==9)&&(z==true)){
					x1=59;
					y1=4;
					seleccion=0;
				}
				break;
			}
			case IZQUIERDA:{ //Cambio de columna
				if ((x1==59)&&(z==true)){
					x1=9;
					y1=5;
					seleccion=(1+(pg*16));
				}
				break;
			}
			case ENTER:{
				if ((x1==9)||(seleccion==0)){ //columna de seleccion de partida o salir
					return seleccion;
				}else if((seleccion==(-1))&&(pg<pgs)) { //Pagina siguiente y menor que el maximo de paginas
					pg++;
					if( ((pg+1)*16) > cantpartidas ){
						cant_filas=(cantpartidas-(16*pg));
					}else{
						cant_filas=16;
					}
					imprimir_grilla_de_partidas(8,2,cant_filas);
					pintar_cuadrito2(58,3);gotoxy(60,4);cout<<(char)186<<"  Salir";
					pintar_cuadrito2(58,7);gotoxy(60,8);cout<<(char)186<<"  Pg. Sig";
					pintar_cuadrito2(58,11);gotoxy(60,12);cout<<(char)186<<"  Pg. Ant";
					imprimir_pagina_partidas(lista,pg);
				}else if((seleccion==(-2))&&(pg>0)) { //Pagina anterior y mayor que la pagina 0
					pg--;
					if( ((pg+1)*16) > cantpartidas ){
						cant_filas=(cantpartidas-(16*pg));
					}else{
						cant_filas=16;
					}
					imprimir_grilla_de_partidas(8,2,cant_filas);
					pintar_cuadrito2(58,3);gotoxy(60,4);cout<<(char)186<<"  Salir";
					pintar_cuadrito2(58,7);gotoxy(60,8);cout<<(char)186<<"  Pg. Sig";
					pintar_cuadrito2(58,11);gotoxy(60,12);cout<<(char)186<<"  Pg. Ant";
					imprimir_pagina_partidas(lista,pg);
				}
				break;
			}
			}
			gotoxy(x1,y1);cout<<(char)175;
		} while(true);
	}
	return 0;
}
bool leer_pendientes(partida & partidapendiente){ //Se leera "Partidas.dat" y se mostraran en pantalla
	ifstream f;//Declaramos el archivo de solo lectura y lo abrimos como archivo binario
	f.open(archPartida, ios::binary );
	partida aux;
	bool haypartida = false;
	int contador=0, contador2=1;
	Nodo2 * lista = NULL, *aux01 ,*nuevo, *anti;
	
	if (f.fail()){
		gotoxy(7,5);cout<<"Error al abrir Partidas.dat";
		gotoxy(7,7);system("PAUSE");
	}else{
		f.read((char*)&aux,sizeof(partida));
		while(!f.eof()){
			if (aux.idUO == usuarioActual.id){
				if (aux.estado==0){
					if (!haypartida){ //Agrega el primer elemento al principio
						haypartida= true;
						aux01 = lista;
						lista = new Nodo2;
						lista->id = contador2;
						lista->ant = NULL;
						lista->info = aux;
						lista->sig = aux01;
					}else{ //Agrega un elemento al final de la lista
						aux01=lista;
						for (aux01 = lista; aux01->sig != NULL; aux01 = aux01->sig){
							if ((aux01->sig)->sig==NULL){
								anti = aux01;
							}
						}
						//Seteamos el nuevo nodo de la lista
						nuevo = new Nodo2;
						nuevo->info = aux;
						nuevo->id = contador2;
						nuevo->ant = anti;
						nuevo->sig = NULL;
						aux01->sig = nuevo;
					}
					contador2++;
				}
				//La siguiente variable contara la cantidad de partidas encontradas
				contador++; 
			}
			f.read((char*)&aux,sizeof(partida));
		}
		
		f.close();
		if(!haypartida){
			gotoxy(25,5);cout <<"No tienes partidas partidas pendientes" ;
			gotoxy(25,7);system("PAUSE");
		}
		else{
			contador=1;
			for (aux01 = lista; aux01->sig != NULL; aux01 = aux01->sig) {
				contador++;
			}
			contador = seleccion_partidas(7,2,lista,contador,true);
			if(contador==0){
				return false;
			}else {
				for (aux01 = lista; aux01->id != contador; aux01 = aux01->sig);
				partidapendiente=aux01->info;
				return true;
			}
		}
	}
	return false;
}
void imprimir_pagina_partidas(Nodo2 * lista, int pg){
	int y1=5,ia=(0+(16*pg)),ib=(ia+16);
	bool asdasd=true;
	usuario user_aux;
	partida partida_aux;
	Nodo2*aux;
	
	for (aux=lista;((aux->id)<=ia);(aux=(aux->sig)));
	//aux=lista;
	while(asdasd){
		partida_aux=(aux->info);
		if (partida_aux.idUO==0){
			user_aux.nombre="IA - COM";
		}else{
			if (usuarioActual.id==partida_aux.idUI){
				buscarXIdUsuario(partida_aux.idUO,user_aux);
			}else{
				buscarXIdUsuario(partida_aux.idUI,user_aux);
			}
		}
		gotoxy(11,y1); 
		cout<<user_aux.nombre;
		gotoxy(22,y1);
		cout<<
			setfill('0') << setw(2) << (int)(partida_aux.idPartida/1000000)%100/*Dia*/ << "/" << 
			setfill('0') << setw(2) << (int)(partida_aux.idPartida/100000000)/*Mes*/ << "/" << 
			setfill('0') << setw(2) << (int)(partida_aux.idPartida/10000)%100/*hora*/ << ":" << 
			setfill('0') << setw(2) << (int)(partida_aux.idPartida/100)%100 /*minutos*/ << ":" << 
			setfill('0') << setw(2) << (int)(partida_aux.idPartida)%100;
		gotoxy(37,y1);
		if (usuarioActual.id==partida_aux.idUI){
			switch(partida_aux.estado){
			case 0:{Color(240);cout<<"Iniciada";break;}
			case 1:{Color(250);cout<<"Ganada!";Color(240);break;}
			case 2:{Color(252);cout<<"Perdida!";Color(240);break;}
			case 3:{Color(245);cout<<"Empatada!";Color(240);break;}
			}
		}else{
			switch(partida_aux.estado){
			case 0:{Color(240);cout<<"Pendiente";break;}
			case 1:{Color(252);cout<<"Perdida!";Color(240);break;}
			case 2:{Color(250);cout<<"Ganada!";Color(240);break;}
			case 3:{Color(245);cout<<"Empatada!";Color(240);break;}
			}
		}
		Color(240);
		y1+=2;
		ia++;
		if ((ia==ib)||(aux->sig == NULL)){
			asdasd=false;
		}else {
			aux= (aux->sig);
		}
	} 
	
}
void imprimir_grilla_de_partidas(int x1, int y1, int cant_filas){
	/* 39 largo, con x1=21 esta centrado, aproximadamente entran 15 filas*/
	cant_filas--;
	transicion(false);
	gotoxy(x1,y1);printf("%c%c%c%c%c%c%c%c%c%c%c%c%c%c%c%c%c%c%c%c%c%c%c%c%c%c%c%c%c%c%c%c%c%c%c%c%c%c%c",201,205,203,205,205,205,205,205,205,205,205,205,205,203,205,205,205,205,205,205,205,205,205,205,205,205,205,205,203,205,205,205,205,205,205,205,205,205,187);
	gotoxy(x1,y1+1);printf("%c %c Nombre   %c Fecha        %c Estado  %c",186,186,186,186,186);
	gotoxy(x1,y1+2);printf("%c%c%c%c%c%c%c%c%c%c%c%c%c%c%c%c%c%c%c%c%c%c%c%c%c%c%c%c%c%c%c%c%c%c%c%c%c%c%c",204,205,206,205,205,205,205,205,205,205,205,205,205,206,205,205,205,205,205,205,205,205,205,205,205,205,205,205,206,205,205,205,205,205,205,205,205,205,185);
	y1+=2;
	for (int i=0;i<=cant_filas;i++){
		gotoxy(x1,y1);printf("%c%c%c%c%c%c%c%c%c%c%c%c%c%c%c%c%c%c%c%c%c%c%c%c%c%c%c%c%c%c%c%c%c%c%c%c%c%c%c",204,205,206,205,205,205,205,205,205,205,205,205,205,206,205,205,205,205,205,205,205,205,205,205,205,205,205,205,206,205,205,205,205,205,205,205,205,205,185);
		gotoxy(x1,y1+1);printf("%c %c          %c              %c         %c",186,186,186,186,186);
		gotoxy(x1,y1+2);printf("%c%c%c%c%c%c%c%c%c%c%c%c%c%c%c%c%c%c%c%c%c%c%c%c%c%c%c%c%c%c%c%c%c%c%c%c%c%c%c",200,205,202,205,205,205,205,205,205,205,205,205,205,202,205,205,205,205,205,205,205,205,205,205,205,205,205,205,202,205,205,205,205,205,205,205,205,205,188);
		y1+=2;
	}
	
}
void pintar_cuadrito2(int a, int b){//se pinta un cuadro de 15x3
	gotoxy(a,b); printf("%c%c%c%c%c%c%c%c%c%c%c%c%c%c%c",201,205,203,205,205,205,205,205,205,205,205,205,205,205,187);
	gotoxy(a,b+1); printf("%c",186);gotoxy(a+14,b+1);printf("%c",186);
	gotoxy(a,b+2); printf("%c%c%c%c%c%c%c%c%c%c%c%c%c%c%c",200,205,202,205,205,205,205,205,205,205,205,205,205,205,188);
}
bool calcular_stats(){
	ifstream f1;
	Nodo* lista = NULL, *aux = NULL, *nuevo = NULL, *anterior = NULL;
	f1.open(archJugada, ios::binary);
	jugada j1;
	
	int contador_posicion=0;
	
	if (f1.fail()){
		gotoxy(0,0);cout<<"Error al abrir el archivo jugada.dat";
		system("PAUSE");
		return false;
	}else{
		/*
		Se hara una lista donde se guardara la idPartida de la jugada y
		la posicion en el archivo. Luego se procesara la lista con acceso
		directo al archivo usando la posicion.
		*/
		f1.read((char*)&j1,sizeof(jugada));
		while(!f1.eof()){//Empieza while (1)
			if (lista==NULL){//Si la lista esta vacia inciciamos el primer nodo de la lista
				lista=new Nodo;
				lista->id = contador_posicion;
				lista->idPartida = j1.idPartida;
				lista->sig = NULL;
			}else{
				aux=lista;
				while((aux->sig != NULL) && (j1.idPartida > aux->idPartida)){//Mientras no sea el ultimo de la lista y la id sea mas reciente
					anterior=aux;
					aux = aux->sig;
				}
				nuevo=new Nodo;
				nuevo->id = contador_posicion;
				nuevo->idPartida = j1.idPartida;
				//Insertar ordenado o al final
				if (aux->sig != NULL){
					anterior->sig = nuevo;
					nuevo->sig = aux;
				}else{
					aux->sig = nuevo;
					nuevo->sig = NULL;
				}
			}
			contador_posicion++;
			f1.read((char*)&j1,sizeof(jugada));
		}//Termina while (1)
		f1.close();
		
		int rtas_correctas=0, ganadas=0, perdidas=0, empatadas=0, iniciadas=0, rtas_correctasdobles=0, categorias[5]={0,0,0,0,0};
		procesar_stats(lista,ganadas,perdidas,empatadas,iniciadas,rtas_correctas,rtas_correctasdobles, categorias);
		
		imprimir_stats(lista,ganadas,perdidas,empatadas,iniciadas,rtas_correctas,rtas_correctasdobles, categorias);	
		return true;
	}
	f1.close();
}
void imprimir_stats(Nodo* lista, int& ganadas, int& perdidas, int& empatadas, int& iniciadas, int& rtas_correctas, int& rtas_correctasdobles, int categorias[]){
	Color(241);
	gotoxy(30,3);cout<<"[Mis estadisticas]";
	Color(252);
	gotoxy(7,8); cout<<"Partidas ganadas..........................................{"<<ganadas<<"}";
	gotoxy(7,10);cout<<"Partidas perdidas.........................................{"<<perdidas<<"}";
	gotoxy(7,12);cout<<"Partidas empatadas........................................{"<<empatadas<<"}";
	gotoxy(7,14);cout<<"Eficacia..................................................";
	if ((ganadas+perdidas+empatadas+iniciadas)!=0){
		cout<<((rtas_correctas*100)/((ganadas+perdidas+empatadas+iniciadas)*10))<<"%";
	}else{
		cout<<"0 %";
	}
	Color(241);
	gotoxy(28,16);cout<<"[Estadisticas Generales]";
	Color(244);
	gotoxy(7,20);cout<< "La categoria Fisica I fue sorteada ..............["<<categorias[0]<<"] veces";
	gotoxy(7,21);cout<< "La categoria Matematica Discreta fue sorteada ...["<<categorias[1]<<"] veces";
	gotoxy(7,22);cout<< "La categoria AEDD fue sorteada ..................["<<categorias[2]<<"] veces";
	gotoxy(7,23);cout<< "La categoria Arq. de Computadoras fue sorteada ..["<<categorias[3]<<"] veces";
	gotoxy(7,24);cout<< "La categoria An. Matematico I fue sorteada ......["<<categorias[4]<<"] veces";
	
	gotoxy(7,26);cout<< "Coincidencia en aciertos para ambos jugadores....["<<rtas_correctasdobles<<"]";
	Color(240);
}
bool procesar_stats(Nodo* lista, int& ganadas, int& perdidas, int& empatadas, int& iniciadas, int& rtas_correctas, int& rtas_correctasdobles, int categorias[]){
	if (lista!=NULL){
		bool findelista=false;
		ifstream f1;
		f1.open(archJugada, ios::binary);
		if(!f1.fail()){
			Nodo* aux;
			aux=lista;//Guardamos la posicion inicial de la lista
			jugada j1,j2;
			while(!findelista){ //Mientras la lista no termine
				if (lista->sig == NULL){//Si el nodo en el que estamos esta al final, sabemos que esta desemparejado. Solo marcaremos el fin de la lista y no moveremos el puntero
					f1.seekg(sizeof(jugada)*(lista->id));//Nos posicionamos en una jugada
					f1.read((char *) &j1, sizeof(jugada));//Cargamos la jugada en una variable
					if(j1.idUsr==usuarioActual.id){
						for(int i=0;i<10;i++){//Procesamos las respuestas
							if(j1.rtas[i]==true){
								rtas_correctas++;
								if (j2.rtas[i]==true) rtas_correctasdobles++;
							}
						}
					}
					findelista=true;
				}else{//El nodo no es el ultimo por lo tanto puede o no estar emparejado
					if(lista->idPartida == (lista->sig)->idPartida){//La jugada esta emparejada con la de al lado?
						f1.seekg(sizeof(jugada)*((lista->sig)->id));//Nos posicionamos en la segunda jugada
						f1.read((char *) &j2, sizeof(jugada));//Levantamos la segunda jugada
						if ((usuarioActual.id==j1.idUsr)||(usuarioActual.id==j2.idUsr)){//Alguna jugada es del jugador acutal?
							if (j1.idUsr==usuarioActual.id){
								for(int i=0;i<10;i++){//Procesamos las respuestas
									if(j1.rtas[i]==true){
										rtas_correctas++;
										if (j2.rtas[i]==true) rtas_correctasdobles++;
									}
								}
							}else{
								for(int i=0;i<10;i++){//Procesamos las respuestas
									if(j2.rtas[i]==true){
										rtas_correctas++;
										if (j1.rtas[i]==true) rtas_correctasdobles++;
									}
								}
							}
							if((lista->sig)->sig!=NULL){//Avanzamos en la lista dos veces
								lista=(lista->sig)->sig;
							}else{
								findelista=true;
							}
						}else{ //Ninguna jugada es del jugador actual, por lo tanto solo procesamos las respuestas
							for(int i=0;i<10;i++){
								if((j1.rtas[i]==true)&&(j2.rtas[i]==true)){
									rtas_correctasdobles++;
								}
							}
							if((lista->sig)->sig!=NULL){//Avanzamos en la lista dos veces
								lista=(lista->sig)->sig;
							}else{
								findelista=true;
							}
						}
					}else{//La partida no esta emparejada por lo tanto solo esta terminada
						if(j1.idUsr==usuarioActual.id){
							for(int i=0;i<10;i++){//Procesamos las respuestas
								if(j1.rtas[i]==true){
									rtas_correctas++;
									if (j2.rtas[i]==true) {
										rtas_correctasdobles++;
									}
								}
							}
						}
						if (lista->sig!=NULL){ //Avanzamos en la lista
							lista = lista->sig;
						}else{
							findelista = true;
						}
					}
				}
			}
			
			lista=aux;//Devolvemos la lista a la posicion inicial
			f1.close();
		}else{
			gotoxy(0,1); cout<<"Error de archivo jugadas.dat";
			system("PAUSE");
			return false;
		}
		f1.open(archPartida, ios::binary);
		partida p1;
		if (!f1.fail()){
			f1.read((char*)&p1,sizeof(partida));
			while(!f1.eof()){
				for (int i=0;i<10;i++){
					switch(p1.categorias[i]){
					case 0:{categorias[0]++;break;}
					case 1:{categorias[1]++;break;}
					case 2:{categorias[2]++;break;}
					case 3:{categorias[3]++;break;}
					case 4:{categorias[4]++;break;}
					}
				}
				if (p1.idUI == usuarioActual.id){
					switch(p1.estado){
					case 1:{ganadas++;break;}
					case 2:{perdidas++;break;}
					case 3:{empatadas++;break;}
					}
				}else if (p1.idUO == usuarioActual.id){
					switch(p1.estado){
					case 1:{perdidas++;break;}
					case 2:{ganadas++;break;}
					case 3:{empatadas++;break;}
					}
				}
				f1.read((char*)&p1,sizeof(partida));
			}
		}else{
			gotoxy(0,2); cout<<"Error de archivo partidas.dat";
			system("PAUSE");
			return false;
		}
		return true;
	}else{
		gotoxy(0,3); cout<<"No hay partidas";
		system("PAUSE");
		return false;
	}
	return false;
}
void actualizar_ids(void){
	int contador = 1;
	usuario prueba;
	while(buscarXIdUsuario(contador,prueba)){
		contador++;
	}
	ids = contador-1;
}
void Nombrar_partida(long& idPartida, int& oponente){ //Este proceso modifica el idPartida y el Oponente. Ocacionalmente resta creditos.
	bool confirmado=false;
	fecha f;
	obtenerFechaActual(f);
	idPartida=f.segs+(f.mins*100)+(f.hora*10000)+(f.dia*1000000)+(f.mes*100000000);
	
	char tecla;
	int posiblesoponentes[3], teclaconvertida;
	actualizar_ids();
	do {
		//Hacer mientras no se haya confirmado un oponente
		
		transicion(false);
		
		mostrar_creditos(33,32);
		
		posiblesoponentes[0]=((rand()%ids)+1);
		posiblesoponentes[1]=((rand()%ids)+1);
		posiblesoponentes[2]=((rand()%ids)+1);
		
		imprimir_ficha(22,4,posiblesoponentes[0]);
		imprimir_ficha(22,12,posiblesoponentes[1]);
		imprimir_ficha(22,20,posiblesoponentes[2]);
		
		gotoxy(57,8);cout<<"1";
		gotoxy(57,16);cout<<"2";
		gotoxy(57,24);cout<<"3";
		gotoxy(15, 30);cout<<"Selecciona un oponente [x] o compra un Re-roll [4]";
		
		
		do{//Va a comenzar a preguntar si elige oponente o re_roll
			tecla=getch();
			teclaconvertida = (tecla - 48);
			
			if (teclaconvertida==4){//Se elige comprar un re roll
				if (actualizar_creditos(4,false,preferenciasActual.id)==false){ //Si no alcanzan los creditos
					gotoxy(25,31);
					Color(252);
					cout<<"NO TIENES CREDITOS SUFICIENTES!";
					Color(240);
					do{
						tecla=getch();
						teclaconvertida = (tecla - 48);
						if ((teclaconvertida>=1) &&(teclaconvertida<=3)){
							oponente=posiblesoponentes[teclaconvertida-1];
							confirmado=true;
						}
					} while(confirmado==false);
				}else{
					transicion(false);
				}
			}else{
				oponente=posiblesoponentes[teclaconvertida-1];
				confirmado=true;
			}
		} while(teclaconvertida<1 && teclaconvertida>4);
		
	} while(confirmado==false);//Si eligio oponente sale del bucle, sino hace el reroll
}
void pintar_cuadrado_color(int x,int y,int genero){ //Este proceso pinta un cuadrado de color
	switch(genero){
	case 1:{Color(247);break;}//gris
	case 2:{Color(249);break;}//azul
	case 3:{Color(253);break;}//rosado
	}
	/*
	gotoxy(x,y);   printf("%c%c%c%c%c%c",219,219,219,219,219,219);
	gotoxy(x,y+1); printf("%c%c%c%c%c%c",219,219,219,219,219,219);
	gotoxy(x,y+2); printf("%c%c%c%c%c%c",219,219,219,219,219,219);
	gotoxy(x,y+3); printf("%c%c%c%c%c%c",219,219,219,219,219,219);
	*/
	gotoxy(x,y);   cout<<"######";
	gotoxy(x,y+1); cout<<"######";
	gotoxy(x,y+2); cout<<"######";
	gotoxy(x,y+3); cout<<"######";
	Color(240);
}
void imprimir_ficha(int x, int y,int id){ //37(x)x6(y)
	usuario usr_aux;
	preferencias pref_aux;
	buscarXIdUsuario(id,usr_aux);
	//cargarpreferencias(pref_aux);
	gotoxy(x,y);   printf("%c%c%c%c%c%c%c%c%c%c%c%c%c%c%c%c%c%c%c%c%c%c%c%c%c%c%c%c%c%c%c%c%c%c%c%c%c\n",201,205,205,205,205,205,205,205,205,203,205,205,205,205,205,205,205,205,205,205,205,205,205,205,205,205,205,205,205,205,205,205,205,205,205,205,187);
	gotoxy(x,y+1); printf("%c        %c NOMBRE:                  %c\n",186,186,186);
	gotoxy(x,y+2); printf("%c        %c ID:                      %c\n",186,186,186);
	gotoxy(x,y+3); printf("%c        %c                        %c%c%c\n",186,186,201,205,185);
	gotoxy(x,y+4); printf("%c        %c             Seleccion> %c %c\n",186,186,186,186);
	gotoxy(x,y+5); printf("%c%c%c%c%c%c%c%c%c%c%c%c%c%c%c%c%c%c%c%c%c%c%c%c%c%c%c%c%c%c%c%c%c%c%c%c%c\n",200,205,205,205,205,205,205,205,205,202,205,205,205,205,205,205,205,205,205,205,205,205,205,205,205,205,205,205,205,205,205,205,205,205,202,205,188);
	
	buscar_preferencias(id , pref_aux );
	
	if (usr_aux.id!=usuarioActual.id){
		gotoxy(x+19,y+1); 
		cout<<usr_aux.nombre;
		gotoxy(x+15,y+2); 
		cout<<setw(3)<<setfill('0')<<usr_aux.id;
		pintar_cuadrado_color(x+2,y+1,pref_aux.genero);
	}else{
		gotoxy(x+19,y+1); 
		cout<<"IA";
		gotoxy(x+15,y+2); 
		cout<<"000";
		pintar_cuadrado_color(x+2,y+1,0);
	}
	
}
bool actualizar_creditos(int creditos,bool suma,int id){//Esta funcion suma o resta creditos y guarda las preferencias en el archivo
	preferencias aux;
	buscar_preferencias(id,aux);
	
	if (suma==true){
		aux.creditos = aux.creditos + creditos;
		guardar_preferencias(aux);
		if (aux.id == preferenciasActual.id){
			emparejar_preferencias();
		}
		return true;
	}else{
		if (aux.creditos>=creditos){
			aux.creditos = aux.creditos - creditos;
			guardar_preferencias(aux);
			if (aux.id == preferenciasActual.id){
				emparejar_preferencias();
			}
			return true;
		}else{
			return false;
		}
	}
}
bool guardar_preferencias(preferencias aux1){ //Esta funcion guarda el estado actual de la variable global
	//system("cls");
	ifstream a;
	a.open(archPreferencias, ios::binary | ios::in );
	preferencias aux;
	if(aux1.id == preferenciasActual.id){
		obtenerFechaActual(aux1.ultimaConexion);
	}
	bool haypreferencia = false;
	int contador=0;
	if (a.fail()){
		
		ofstream f;//Declaramos el archivo de salida y lo abrimos como archivo binario
		f.open(archPreferencias, ios::binary | ios::out);
		f.write((char*)&aux1,sizeof(preferencias));
		f.close();
		
		return false;
	}else{
		
		a.read((char*)&aux,sizeof(preferencias));
		while((!a.eof()) && (haypreferencia==false)){
			if (aux1.id == aux.id){
				
				haypreferencia = true;
			}else{
				
				contador++;
				a.read((char*)&aux,sizeof(preferencias));
			}
		}
		a.close();
		
		ofstream f;
		f.open(archPreferencias, ios::binary | ios::in | ios::out );
		f.seekp(sizeof(preferencias)*contador);
		f.write((char*)&aux1,sizeof(preferencias));
		f.close();
		
		
		return true;
	}
	
	return false;
}
void mostrar_creditos(int x1,int y1){
	if (preferenciasActual.creditos<10)Color(252);
	pintar_cuadrito(x1,y1);
	gotoxy(x1+2,y1);
	cout<<"TusCreditos";
	gotoxy(x1+6,y1+1);
	cout<<setw(3)<<setfill('0')<<preferenciasActual.creditos;
	Color(240);
}
void emparejar_preferencias(void){ //Esta funcion actualiza el estado de la variable global 
	ifstream f;
	preferencias aux;
	bool control = false;
	f.open(archPreferencias, ios::binary);
	if (f.fail()){
		//cout<<"Error al emparejar preferencias";
		aux.id = usuarioActual.id;
		aux.color=240;
		aux.fondo=false;
		aux.genero = 0;
		aux.creditos = 30;
		obtenerFechaActual(aux.ultimaConexion);
		preferenciasActual=aux;
		ofstream a;
		a.open(archPreferencias, ios::binary | ios::ate | ios::app);
		a.write((char *) &aux, sizeof(preferencias));
		a.close();
	}else{
		f.read((char*)&aux,sizeof(preferencias));
		while((!f.eof())&&(control==false)){
			if (aux.id==usuarioActual.id){
				preferenciasActual=aux;
				control=true;
				//cout<<"Encontro"<<endl;
			}else{
				f.read((char*)&aux,sizeof(preferencias));
				//cout<<"Busca"<<endl;
			}
		}
		if(f.eof()){
			//cout<<"No encontro"<<endl;
			aux.id = usuarioActual.id;
			aux.genero = 0;
			aux.creditos = 20;
			obtenerFechaActual(aux.ultimaConexion);
			preferenciasActual=aux;
			ofstream a;
			a.open(archPreferencias, ios::binary | ios::ate | ios::app);
			a.write((char *) &aux, sizeof(preferencias));
			a.close();
		}
		f.close();
	}
	//system("PAUSE");
}
bool buscar_preferencias(int id, preferencias & aux1){
	ifstream a;
	a.open(archPreferencias, ios::binary);
	preferencias aux2;
	bool haypreferencia = false;
	aux2.id=0;
	//La idea es buscar las preferencias segun la id y cargarla en el parametro
	a.read((char *) &aux2, sizeof(preferencias));
	do{
		if (usuarioActual.id == aux2.id){
			haypreferencia = true;
			aux1 = aux2;
			a.close();
			return true;
		}else{
			if (!a.eof()){
				a.read((char *) &aux2, sizeof(preferencias));
			}else{
				a.close();
				return false;
			}
		}
	}while(true);
}
void micuenta(){
	transicion(false);
	bool aux1=false;
	int aux2;
	char a;
	Color(241);
	gotoxy(5,8); cout<<"Eres el usuario nro "<<usuarioActual.id<<" en registrarte!";
	gotoxy(5,10);cout<<"Cuenta: "<<usuarioActual.nombre;
	gotoxy(5,12);cout<<"Contrase"<<(char)nn<<"a: "<<usuarioActual.clave;
	gotoxy(5,14);cout<<"Creditos: "<<preferenciasActual.creditos;
	gotoxy(5,16);cout<<"Genero: ";
	switch(preferenciasActual.genero){
		case 0:{
			cout<<"No definido";
			break;
		}	
		case 1:{
			cout<<"Hombre";
			break;
		}
		case 2:{
			cout<<"Mujer";
			break;
		}
	}
	gotoxy(5,18);cout<<"Ultima conexion registrada: "
		<<setw(2)<<setfill('0')<<preferenciasActual.ultimaConexion.dia<<"/"
		<<setw(2)<<setfill('0')<<preferenciasActual.ultimaConexion.mes<<"/"
		<<preferenciasActual.ultimaConexion.anio<<" a las "
		<<setw(2)<<setfill('0')<<preferenciasActual.ultimaConexion.hora<<":"
		<<setw(2)<<setfill('0')<<preferenciasActual.ultimaConexion.mins<<":"
		<<setw(2)<<setfill('0')<<preferenciasActual.ultimaConexion.segs;
	gotoxy(4,34);cout<<"Para cambiar su genero presione:";
	gotoxy(8,35);cout<<"[0] -> No define";
	gotoxy(8,36);cout<<"[1] -> Hombre";
	gotoxy(8,37);cout<<"[2] -> Mujer";
	gotoxy(4,38);cout<<"Para salir y guardar presione [4]";
	do{
		a=getch();
		gotoxy(13,16);
		switch((int)a){
			case (int)'0':{
				cout<<"No definido ";
				preferenciasActual.genero=0;
				break;
			}
			case (int)'1':{
				cout<<"Hombre      ";
				preferenciasActual.genero=1;
				break;
			}
			case (int)'2':{
				cout<<"Mujer       ";
				preferenciasActual.genero=2;
				break;
			}
			case (int)'4':{
				aux1=true;
				break;
			}
		}
	} while(aux1==false);
	
	guardar_preferencias(preferenciasActual);
	Color(240);
}
void Jugar_vs_com(jugada RuedaPreguntas,partida Nueva){
	gotoxy(6,8);
	cout<<"Nuestra IA esta pensando... ";
	grilla(4,10,true);
	for(int i=0;i<10;i++){//Se mostrara Visualmente las respuestas tuyas
		gotoxy((8+(7*i)),13);
		if (RuedaPreguntas.rtas[i] == true){
			Color(250);
			cout<<(char)251;
		}else{
			Color(252);
			cout<<"x";
		}
	}
	//Aqui comienza a jugar la supuesta IA
	jugada InteligenciaArtificial;
	InteligenciaArtificial.puntaje=0;
	int respuesta;
	for(int j=0;j<10;j++){
		gotoxy((8+(7*j)),15);
		//Aca se hace un rand modulo 4 para que la IA sea mas facil
		respuesta=(rand()%3);//Para aumentar la facilidad, aumentar el modulo del rand()
		if (respuesta==0){
			InteligenciaArtificial.rtas[j]=true;
		}else{
			InteligenciaArtificial.rtas[j]=false;
		}
		if (InteligenciaArtificial.rtas[j] == true){
			Color(250);
			cout<<(char)251;
			InteligenciaArtificial.puntaje+=3;
		}else{
			Color(252);
			cout<<"x";
		}
		Sleep(1000);
		switch(rand()%3){
		case 0:{Sleep(0);break;}
		case 1:{Sleep(300);break;}
		case 2:{Sleep(600);break;}
		case 3:{Sleep(900);break;}
		case 4:{Sleep((rand()%2000)+1000);break;}
		}
	}
	if (RuedaPreguntas.puntaje>=InteligenciaArtificial.puntaje){
		if(RuedaPreguntas.puntaje==InteligenciaArtificial.puntaje){
			actualizar_creditos(4,true,RuedaPreguntas.idUsr);
			Nueva.estado=3; // Empate
			Color(249); gotoxy(15,26); cout<<"EMPATE!";Color(240);
		}else if (RuedaPreguntas.puntaje>InteligenciaArtificial.puntaje){
			actualizar_creditos(10,true,RuedaPreguntas.idUsr);
			Nueva.estado=1; // Iniciador gana
			Color(250); gotoxy(15,26); cout<<"GANASTE!";Color(240);
		}else if (RuedaPreguntas.puntaje<InteligenciaArtificial.puntaje){
			Nueva.estado=2; // Iniciador pierde
			Color(252); gotoxy(15,26); cout<<"PERDISTE!";Color(240);
		}
	}
	InteligenciaArtificial.idUsr=0;
	Nueva.idUO=0;
	guardar_jugadas(RuedaPreguntas);
	guardar_jugadas(InteligenciaArtificial);
	guardar_partidas(Nueva);
	guardar_preferencias(preferenciasActual);
	gotoxy(24,2);Color(249);cout<<"[Los creditos ya se han guardado]";
	gotoxy(0,0);
	system("PAUSE");
	Color(240);
}
bool control_de_usuario(){
	int l=0,j=0,k=0;
	bool v=true;
	Color(252);//Color rojo
	k=usuarioActual.nombre.size();//Toma el tamao del user ingresado
	if (usuarioActual.nombre[0]<97 || usuarioActual.nombre[0]>122){ //Revisa que el primer caracter este entre las minusculas
		gotoxy(4,7);cout<<"El primer caracter no es minuscula!";
		v=false;
	}else {
		gotoxy(4,7);cout<<"                                  ";
	}
	for(int i=0;i<=k;i++){
		if (usuarioActual.nombre[i]>47 && usuarioActual.nombre[i]<58) l++;//Cuenta los numeros dentro del string
		if (usuarioActual.nombre[i]>64 && usuarioActual.nombre[i]<91) j++;//Cuenta las mayus dentro del string
		if ((usuarioActual.nombre[i]<65 && usuarioActual.nombre[i]>90)&&
			(usuarioActual.nombre[i]<97 && usuarioActual.nombre[i]>122)&&
			(usuarioActual.nombre[i]<48 && usuarioActual.nombre[i]>57)&&
			(usuarioActual.nombre[i]!=43)&&(usuarioActual.nombre[i]!=45)&&
			(usuarioActual.nombre[i]!=47)&&(usuarioActual.nombre[i]!=42)&&
			(usuarioActual.nombre[i]!=63)&&(usuarioActual.nombre[i]!=168)&&
			(usuarioActual.nombre[i]!=33)&&(usuarioActual.nombre[i]!=173)){
			
			gotoxy(4,11);cout<<"Hay caracteres no validos ingresados!";
			v=false;
			
		}else {
			gotoxy(4,11);cout<<"                                     ";
		}
	}
	gotoxy(4,8);cout<<"                   ";
	gotoxy(4,9);cout<<"                     ";
	gotoxy(4,10);cout<<"                            ";
	gotoxy(4,11);cout<<"                             ";
	if (l>3) {gotoxy(4,8);cout<<"Demasiados numeros!";v=false;}
	if (j<=1){gotoxy(4,9);cout<<"Muy pocas mayusculas!";v=false;}
	if (k>10){gotoxy(4,10);cout<<"Capacidad excedida!";v=false;}
	if (k==0){gotoxy(4,10);cout<<"No se ingresaron caracteres!";v=false;}
	usuario chequeo;
	if (v==true){
		if(!buscarXNombreUsuario(usuarioActual.nombre, chequeo)){
			Color(250);
			gotoxy(9,10);
			cout<<"USUARIO "<<usuarioActual.nombre<<" ACEPTADO!";
		}else{
			gotoxy(4,11);cout<<"Usuario ya Registrado!";
			v=false;
			gotoxy(9,12);system("PAUSE");
		}
	}
	Color (240);
	return v;
}
bool control_de_contrasena(){
	int j=0,k=0;
	bool v=true;
	k=usuarioActual.clave.size();//Se toma el tamao de la contrasea
	Color(252);
	for(int i=0;i<=k;i++){
		//Si un caracter y el siguiente son letras
		if (((usuarioActual.clave[i]>64 && usuarioActual.clave[i]<91) || (usuarioActual.clave[i]>96 && usuarioActual.clave[i]<123))&&
			((usuarioActual.clave[i+1]>64 && usuarioActual.clave[i+1]<91) || (usuarioActual.clave[i+1]>96 && usuarioActual.clave[i+1]<123))){
			//Si una letra es igual al siguiente(-1) y en caso de que siguiente sea minuscula siguiente(-33)
			if ((usuarioActual.clave[i]==((usuarioActual.clave[i+1])-1))||((usuarioActual.clave[i]==((usuarioActual.clave[i+2])-33)))){
				gotoxy(9,18);cout<<"Se ingresaron mas de dos letras alfabeticamente consecutivas";
				v=false;
			}
		}else{
			gotoxy(9,18);cout<<"                                                            ";
		}
		//Si un caracter y los dos siguientes son caracteres numericos
		if ((usuarioActual.clave[i]>47 && usuarioActual.clave[i]<58) && 
			(usuarioActual.clave[i+1]>47 && usuarioActual.clave[i+1]<58) && 
			(usuarioActual.clave[i+2]>47 && usuarioActual.clave[i+2]<58)){
			gotoxy(9,19);cout<<"Demasiados numeros consecutivos";
			v=false;
		}/*else {
		gotoxy(9,19);cout<<"                               ";
		}*/
		if (usuarioActual.clave[i]>64 && usuarioActual.clave[i]<96) j++;
	}
	gotoxy(9,19);cout<<"                               ";
	gotoxy(9,20);cout<<"                 ";
	gotoxy(9,21);cout<<"                    ";
	if (j==0){gotoxy(9,20);cout<<"No hay mayusculas";v=false;}
	if (k>8){gotoxy(9,21);cout<<"Contrase"<<(char)nn<<"a muy larga";v=false;}
	if (k<6){gotoxy(9,21);cout<<"Contrase"<<(char)nn<<"a muy corta";v=false;}
	Color(240);
	return v;
}
void guardar_usuario(){
	
	ofstream f;
	f.open(archUsuarios, ios::app );
	bool rta=true;
	usuario usrBusc;
	
	actualizar_ids();
	usuarioActual.id = ids+1;
	
	if(!f.fail()){
		if(buscarXNombreUsuario(usuarioActual.nombre,usrBusc)){
			cout << "El nombre de usuario ya existe." << endl;
			rta = false;
		}else{
			f << usuarioActual.id << " " << usuarioActual.nombre << " " << usuarioActual.clave << endl ;
			f.close();
		}
	}
	
	actualizar_ids();
	
}
bool registrar_usuarios(){
	int intentos=0;
	
	//Preparamos la interfaz
	Color(240);
	transicion(false);
	MostrarCursor(true);	
	gotoxy(4,4);cout<<"Ingrese usuario a registrar: "<<endl;
	
	//Ingresamos el nuevo usuario a registrar, mientras no de error
	do{
		gotoxy(4,6);
		cin>>ws>>usuarioActual.nombre;
		intentos++;
	} while((control_de_usuario()==false)&&(intentos <= 3));
	if(intentos<=3){
		intentos=0;
		do{
			Color(240);
			MostrarCursor(true);
			gotoxy(5,16); cout<<"                          ";
			gotoxy(4,14);cout<<"Ingrese contrase"<<(char)nn<<"a"<<endl;
			gotoxy(4,16);gotoxy(9,12);cout<<"                                        ";
			gotoxy(4,16);cin>>ws>>usuarioActual.clave;
			intentos++;
		} while((control_de_contrasena()==false)&&(intentos<=3));
		if (intentos<=3){
			guardar_usuario();
		}
	}
}
string ExePath() {
	char buffer[MAX_PATH];
	GetModuleFileName( NULL, buffer, MAX_PATH );
	string::size_type pos = string( buffer ).find_last_of( "\\/" );
	return string( buffer ).substr( 0, pos);
}
void ayudita(int correcta){
	if (actualizar_creditos(5,false,preferenciasActual.id)){
		Color(252);
		int ayuda;
		ayuda=(((rand())%4)+1);
		while(ayuda==correcta){
			ayuda=(((rand())%4)+1);
		}
		gotoxy(24,28);
		cout<<ayuda<<" seguro NO es correcta!";
	}else{
		gotoxy(24,28);
		cout<<"NO TIENES MAS CREDITOS!          ";
	}
}
void cargarCategorias() {
	const char * categor="categorias.txt";
	ifstream catego;
	catego.open(categor, ios::in);
	int i=0;
	while(!catego.eof()){
		getline(catego,categorias[i],' ');
		string temp; 
		getline(catego,temp,' ');
		tamanoCategorias[i] = atoi(temp.c_str());
		i++;
	}
}
